      PROGRAM  TALL
C     (ELEFUNT Test)
C     Master program to run all of the FORTRAN ELEFUNT ELEmentary
C     FUNction Tests.  This version diverts error messages to the
C     listing file so that they are interspersed with the  normal
C     output, and requests  output of all  error messages.
C
C     The original  main  programs  have all  been  converted  to
C     subroutines.  All magic floating-point constants have  been
C     identified and  recomputed  to  55 figures  in  REDUCE  and
C     inserted in  place of  existing constants.   Comment  lines
C     beginning "C#" flag their occurrence.
C     (17-JAN-86)
      INTEGER          IOUT,MSGLIM
C     REAL*16          DFLMAX
C
      DATA             IOUT    / 6 /
      DATA             MSGLIM  / 999999 /
C
C     CALL ERRSET (MSGLIM,I), where i =
C       0       integer overflow
C       1       integer divide check
C       4       floating overflow
C       5       floating divide check
C       6       floating underflow
C       8       library routine error
C       9       output field width too small
C
C     CALL ERRSET (MSGLIM,0)
C     CALL ERRSET (MSGLIM,1)
C     CALL ERRSET (MSGLIM,4)
C     CALL ERRSET (MSGLIM,5)
C     CALL ERRSET (MSGLIM,6)
C     CALL ERRSET (MSGLIM,8)
C     CALL ERRSET (MSGLIM,9)
C
C     OPEN (UNIT=IOUT,ACCESS='SEQUENTIAL',FORM='FORMATTED',
C    X     STATUS='UNKNOWN')
C
C     Divert error messages to unit 6 as well (TOPS-20 only).
C
C     CALL DIVERT (6)
C
C     CALL TRPFPE (999999,dflmax())
C
      CALL TSMACH (IOUT)
      CALL TQLOG (IOUT)
      CALL TQASIN (IOUT)
      CALL TQATAN (IOUT)
      CALL TQEXP (IOUT)
      CALL TPOWER (IOUT)
      CALL TQSIN (IOUT)
      CALL TQSINH (IOUT)
      CALL TQSQRT (IOUT)
      CALL TQTAN (IOUT)
      CALL TQTANH (IOUT)
      STOP
      END
      SUBROUTINE  TQASIN (IOUT)
C     PROGRAM TO TEST QASIN/QACOS
C
C     DATA REQUIRED
C
C        NONE
C
C     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
C
C        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
C                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
C                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
C                 BE DELETED PROVIDED THE FOLLOWING FOUR
C                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
C
C                 IBETA  - THE RADIX OF THE FLOATING-POINT SYSTEM
C                 IT     - THE NUMBER OF BASE-IBETA DIGITS IN THE
C                          SIGNIFICAND OF A FLOATING-POINT NUMBER
C                 IRND   - 0 IF FLOATING-POINT ADDITION CHOPS,
C                          1 IF FLOATING-POINT ADDITION ROUNDS
C                 MINEXP - THE LARGEST IN MAGNITUDE NEGATIVE
C                          INTEGER SUCH THAT QFLOAT(IBETA)**MINEXP
C                          IS A POSITIVE FLOATING-POINT NUMBER
C
C        QRAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1)
C
C
C     STANDARD FORTRAN SUBPROGRAMS REQUIRED
C
C         QABS, QACOS, QLOG, QLOG10, QMAX1, QASIN, QFLOAT, IDINT, QSQRT
C
C
C     LATEST REVISION - DECEMBER 6, 1979
C
C     AUTHOR - W. J. CODY
C              ARGONNE NATIONAL LABORATORY
C
C
      INTEGER I,IBETA,IEXP,IOUT,IRND,IT,I1,J,K,K1,K2,K3,L,M,
     X        MACHEP,MAXEXP,MINEXP,N,NEGEP,NGRD
      REAL*16 A,AIT,ALBETA,B,BETA,BETAP,C1,C2,DEL,EPS,EPSNEG,       HALF
     X,QRAN,R6,R7,S,SUM,W,X,XL,XM,XMAX,XMIN,XN,X1,Y,YSQ,Z,          ZERO
     X, ZZ
C
C     IOUT = 6
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      BETA = QEXT(FLOAT(IBETA))
      ALBETA = QLOG(BETA)
      ZERO = 0.0Q+00
      HALF = 0.5Q+00
      AIT = QEXT(FLOAT(IT))
      K = IQINT(QLOG10(BETA**IT)) + 1
      IF (IBETA .NE. 10) GO TO 20
      C1 = 1.57Q+00
C#    C2 = 7.9632679489661923132D-4
C#    C2 = (PI/2) - 1.57
      C2 = 7.9632679489661923132169163975144209858469968755291049Q-04
      GO TO 30
   20 C1 = 201.0Q+00/128.0Q+00
C#    C2 = 4.8382679489661923132D-4
C#    C2 = (PI/2) - 201/128
      C2 = 4.8382679489661923132169163975144209858469968755291049Q-04
   30 A = -0.125Q+00
      B = -A
      N = 2000
      XN = QEXT(FLOAT(N))
      I1 = 0
      L = -1
C-----------------------------------------------------------------
C     RANDOM ARGUMENT ACCURACY TESTS
C-----------------------------------------------------------------
      DO 300 J = 1, 5
         K1 = 0
         K3 = 0
         L = -L
         X1 = ZERO
         R6 = ZERO
         R7 = ZERO
         DEL = (B - A) / XN
         XL = A
C
         DO 200 I = 1, N
            X = DEL*QRAN(I1) + XL
            IF (J .LE. 2) GO TO 40
            YSQ = HALF - HALF*QABS(X)
            X = (HALF - (YSQ+YSQ)) + HALF
            IF (J .EQ. 5) X = -X
            Y = QSQRT(YSQ)
            Y = Y + Y
            GO TO 50
   40       Y = X
            YSQ = Y*Y
   50       SUM = ZERO
            XM = QEXT(FLOAT(K+K+1))
            IF (L .GT. 0) Z = QASIN(X)
            IF (L .LT. 0) Z = QACOS(X)
C
            DO 60 M = 1, K
               SUM = YSQ*(SUM + 1.0Q+00/XM)
               XM = XM - 2.0Q+00
               SUM = SUM*(XM/(XM+1.0Q+00))
   60       CONTINUE
C
            SUM = SUM*Y
            IF ((J .NE. 1) .AND. (J .NE. 4)) GO TO 70
            ZZ = Y + SUM
            SUM = (Y - ZZ) + SUM
            IF (IRND .NE. 1) ZZ = ZZ + (SUM+SUM)
            GO TO 110
   70       S = C1 + C2
            SUM = ((C1 - S) + C2) - SUM
            ZZ = S + SUM
            SUM = ((S - ZZ) + SUM) - Y
            S = ZZ
            ZZ = S + SUM
            SUM = (S - ZZ) + SUM
            IF (IRND .NE. 1) ZZ = ZZ + (SUM+SUM)
  110       W = 1.0Q+00
            IF (Z .NE. ZERO) W = (Z-ZZ)/Z
            IF (W .GT. ZERO) K1 = K1 + 1
            IF (W .LT. ZERO) K3 = K3 + 1
            W = QABS(W)
            IF (W .LE. R6) GO TO 120
            R6 = W
            X1 = X
  120       R7 = R7 + W*W
            XL = XL + DEL
  200    CONTINUE
C
         K2 = N - K3 - K1
         R7 = QSQRT(R7/XN)
         IF (L .LT. 0) GO TO 210
         WRITE (IOUT,1000)
         WRITE (IOUT,1010) N,A,B
         WRITE (IOUT,1011) K1,K2,K3
         GO TO 220
  210    WRITE (IOUT,1005)
         WRITE (IOUT,1010) N,A,B
         WRITE (IOUT,1012) K1,K2,K3
  220    WRITE (IOUT,1020) IT,IBETA
         W = -999.0Q+00
         IF (R6 .NE. ZERO) W = QLOG(QABS(R6))/ALBETA
         WRITE (IOUT,1021) R6,IBETA,W,X1
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         W = -999.0Q+00
         IF (R7 .NE. ZERO) W = QLOG(QABS(R7))/ALBETA
         WRITE (IOUT,1023) R7,IBETA,W
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         IF (J .NE. 2) GO TO 250
         A = 0.75Q+00
         B = 1.0Q+00
  250    IF (J .NE. 4) GO TO 300
         B = -A
         A = -1.0Q+00
         C1 = C1 + C1
         C2 = C2 + C2
         L = -L
  300 CONTINUE
C-----------------------------------------------------------------
C     SPECIAL TESTS
C-----------------------------------------------------------------
      WRITE (IOUT,1025)
      WRITE (IOUT,1030)
C
      DO 320 I = 1, 5
         X = QRAN(I1)*A
         Z = QASIN(X) + QASIN(-X)
         WRITE (IOUT,1060) X, Z
  320 CONTINUE
C
      WRITE (IOUT,1031)
      BETAP = BETA ** IT
      X = QRAN(I1) / BETAP
C
      DO 330 I = 1, 5
         Z = X - QASIN(X)
         WRITE (IOUT,1060) X, Z
         X = X / BETA
  330 CONTINUE
C
      WRITE (IOUT,1035)
      X = BETA ** (QEXT(FLOAT(MINEXP))*0.75Q+00)
      Y = QASIN(X)
      WRITE (IOUT,1061) X, Y
C-----------------------------------------------------------------
C     TEST OF ERROR RETURNS
C-----------------------------------------------------------------
      WRITE (IOUT,1050)
      X = 1.2Q+00
      WRITE (IOUT,1052) X
      Y = QASIN(X)
      WRITE (IOUT,1055) Y
      WRITE (IOUT,1100)
      RETURN
 1000 FORMAT(35H1TEST OF QASIN(X) VS TAYLOR SERIES //)
 1005 FORMAT(35H1TEST OF QACOS(X) VS TAYLOR SERIES //)
 1010 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,1H(,D15.4,1H,,D15.4,1H)//)
 1011 FORMAT(20H QASIN(X) WAS LARGER,I6,7H TIMES, /
     X     13X,7H AGREED,I6,11H TIMES, AND /
     X   9X,11HWAS SMALLER,I6,7H TIMES.//)
 1012 FORMAT(20H QACOS(X) WAS LARGER,I6,7H TIMES, /
     X     12X,7H AGREED,I6,11H TIMES, AND /
     X   8X,11HWAS SMALLER,I6,7H TIMES.//)
 1020 FORMAT(10H THERE ARE,I4,5H BASE,I4,
     X    46H SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER  //)
 1021 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6)
 1022 FORMAT(27H THE ESTIMATED LOSS OF BASE,I4,
     X  22H SIGNIFICANT DIGITS IS,F7.2//)
 1023 FORMAT(40H THE ROOT MEAN SQUARE RELATIVE ERROR WAS,D15.4,
     X    3H = ,I4,3H **,F7.2)
 1025 FORMAT(14H1SPECIAL TESTS//)
 1030 FORMAT(53H THE IDENTITY  QASIN(-X) = -QASIN(X)  WILL BE TESTED.//
     X      8X,1HX,9X,12HF(X) + F(-X)/)
 1031 FORMAT(53H THE IDENTITY QASIN(X) = X , X SMALL, WILL BE TESTED.//
     X       8X,1HX,9X,8HX - F(X)/)
 1035 FORMAT(43H TEST OF UNDERFLOW FOR VERY SMALL ARGUMENT. /)
 1050 FORMAT(22H1TEST OF ERROR RETURNS//)
 1052 FORMAT(39H QASIN WILL BE CALLED WITH THE ARGUMENT,D15.4/
     X       37H THIS SHOULD TRIGGER AN ERROR MESSAGE//)
 1055 FORMAT(25H QASIN RETURNED THE VALUE,D15.4///)
 1060 FORMAT(D15.7,D25.17/)
 1061 FORMAT(6X,7H QASIN(,D13.6,3H) =,D13.6/)
 1100 FORMAT(25H THIS CONCLUDES THE TESTS )
C     ---------- LAST CARD OF QASIN/QACOS TEST PROGRAM ----------
      END
      SUBROUTINE  TQATAN (IOUT)
C     PROGRAM TO TEST QATAN, QATAN2
C
C     DATA REQUIRED
C
C        NONE
C
C     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
C
C        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
C                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
C                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
C                 BE DELETED PROVIDED THE FOLLOWING SIX
C                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
C
C                 IBETA  - THE RADIX OF THE FLOATING-POINT SYSTEM
C                 IT     - THE NUMBER OF BASE-IBETA DIGITS IN THE
C                          SIGNIFICAND OF A FLOATING-POINT NUMBER
C                 IRND   - 0 IF FLOATING-POINT ADDITION CHOPS,
C                          1 IF FLOATING-POINT ADDITION ROUNDS
C                 MINEXP - THE LARGEST IN MAGNITUDE NEGATIVE
C                          INTEGER SUCH THAT QFLOAT(IBETA)**MINEXP
C                          IS A POSITIVE FLOATING-POINT NUMBER
C                 XMIN   - THE SMALLEST NON-VANISHING FLOATING-POINT
C                          POWER OF THE RADIX
C                 XMAX   - THE LARGEST FINITE FLOATING-POINT NO.
C
C        QRAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1)
C
C     STANDARD FORTRAN SUBPROGRAMS REQUIRED
C
C         QABS, QLOG, QMAX1, QATAN, QATAN2, QFLOAT, QSQRT
C
C
C     LATEST REVISION - DECEMBER 6, 1979
C
C     AUTHOR - W. J. CODY
C              ARGONNE NATIONAL LABORATORY
C
C
      INTEGER I,IBETA,IEXP,IOUT,IRND,II,IT,I1,J,K1,K2,K3,MACHEP,
     X        MAXEXP,MINEXP,N,NEGEP,NGRD
      REAL*16 A,AIT,ALBETA,B,BETA,BETAP,DEL,EM,EPS,EPSNEG,
     X     EXPON,HALF,OB32, ONE,QRAN,R6,R7,SUM,TWO,W,X,XL,XMAX,XMIN,XN,
     X     XSQ,X1,Y,Z,ZERO,ZZ
C
C     IOUT = 6
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      BETA = QEXT(FLOAT(IBETA))
      ALBETA = QLOG(BETA)
      AIT = QEXT(FLOAT(IT))
      ONE = 1.0Q+00
      HALF = 0.5Q+00
      TWO = 2.0Q+00
      ZERO = 0.0Q+00
      A = -0.0625Q+00
      B = -A
      OB32 = B * HALF
      N = 2000
      XN = QEXT(FLOAT(N))
      I1 = 0
C-----------------------------------------------------------------
C     RANDOM ARGUMENT ACCURACY TESTS
C-----------------------------------------------------------------
      DO 300 J = 1, 4
         K1 = 0
         K3 = 0
         X1 = ZERO
         R6 = ZERO
         R7 = ZERO
         DEL = (B - A) / XN
         XL = A
C
         DO 200 I = 1, N
            X = DEL * QRAN(I1) + XL
            IF (J .EQ. 2) X = ((1.0Q+00+X*A)-ONE)*16.0Q+00
            Z = QATAN(X)
            IF (J .NE. 1) GO TO 100
            XSQ = X * X
C
C           USE 7 TERMS FOR 18 DECIMAL FIGURES, 16 FOR 40 DECIMAL FIGURES
C           (TAYLOR SERIES ERROR = (1/16)**M/(2*M+1))
C
            EM = QEXT(FLOAT(2*(16 + 1) + 1))
            SUM = XSQ / EM
            DO 80 II = 1, 16
               EM = EM - TWO
               SUM = (ONE/EM - SUM) * XSQ
   80       CONTINUE
C
            SUM = -X * SUM
            ZZ = X + SUM
            SUM = (X - ZZ) + SUM
            IF (IRND .EQ. 0) ZZ = ZZ + (SUM + SUM)
            GO TO 110
  100       IF (J .NE. 2) GO TO 105
            Y = X - 0.0625Q+00
            Y = Y / (ONE + X*A)
C#          ZZ = (QATAN(Y) - 8.1190004042651526021D-5) + OB32
C#          ZZ = (QATAN(Y) - ((1/16) - ATAN(1/16))) + OB32
            ZZ = (QATAN(Y) -
     X    8.11900040426515260208870144948863937261122025008053925Q-05)
     X    + OB32
            ZZ = ZZ + OB32
            GO TO 110
  105       Z = Z + Z
            Y = X / ((HALF + X * HALF)*((HALF - X) + HALF))
            ZZ = QATAN(Y)
  110       W = ONE
            IF (Z .NE. ZERO) W = (Z - ZZ) / Z
            IF (W .GT. ZERO) K1 = K1 + 1
            IF (W .LT. ZERO) K3 = K3 + 1
            W = QABS(W)
            IF (W .LE. R6) GO TO 120
            R6 = W
            X1 = X
  120       R7 = R7 + W * W
            XL = XL + DEL
  200    CONTINUE
C
         K2 = N - K3 - K1
         R7 = QSQRT(R7/XN)
         IF (J .EQ. 1) WRITE (IOUT,1000)
         IF (J .EQ. 2) WRITE (IOUT,1001)
         IF (J .GT. 2) WRITE (IOUT,1002)
         WRITE (IOUT,1010) N,A,B
         WRITE (IOUT,1011) K1,K2,K3
         WRITE (IOUT,1020) IT,IBETA
         W = -999.0Q+00
         IF (R6 .NE. ZERO) W = QLOG(QABS(R6))/ALBETA
         WRITE (IOUT,1021) R6,IBETA,W,X1
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         W = -999.0Q+00
         IF (R7 .NE. ZERO) W = QLOG(QABS(R7))/ALBETA
         WRITE (IOUT,1023) R7,IBETA,W
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         A = B
         IF (J .EQ. 1) B = TWO - QSQRT(3.0Q+00)
         IF (J .EQ. 2) B = QSQRT(TWO) - ONE
         IF (J .EQ. 3) B = ONE
  300 CONTINUE
C-----------------------------------------------------------------
C     SPECIAL TESTS
C-----------------------------------------------------------------
      WRITE (IOUT,1025)
      WRITE (IOUT,1030)
      A = 5.0Q+00
C
      DO 320 I = 1, 5
         X = QRAN(I1) * A
         Z = QATAN(X) + QATAN(-X)
         WRITE (IOUT,1060) X, Z
  320 CONTINUE
C
      WRITE (IOUT,1031)
      BETAP = BETA ** IT
      X = QRAN(I1) / BETAP
C
      DO 330 I = 1, 5
         Z = X - QATAN(X)
         WRITE (IOUT,1060) X, Z
         X = X / BETA
  330 CONTINUE
C
      WRITE (IOUT,1032)
      A = -TWO
      B = 4.0Q+00
C
      DO 340 I = 1, 5
         X = QRAN(I1) * B + A
         Y = QRAN(I1)
         W = -Y
         Z = QATAN(X/Y) - QATAN2(X,Y)
         ZZ = QATAN(X/W) - QATAN2(X,W)
         WRITE (IOUT,1059) X, Y, Z, ZZ
  340 CONTINUE
C
      WRITE (IOUT,1035)
      EXPON = QEXT(FLOAT(MINEXP)) * 0.75Q+00
      X = BETA ** EXPON
      Y = QATAN(X)
      WRITE (IOUT,1061) X, Y
C-----------------------------------------------------------------
C     TEST OF ERROR RETURNS
C-----------------------------------------------------------------
      WRITE (IOUT,1050)
      WRITE (IOUT,1051) XMAX
      Z = QATAN(XMAX)
      WRITE (IOUT,1061) XMAX, Z
      X = ONE
      Y = ZERO
      WRITE (IOUT,1053) X, Y
      Z = QATAN2(X,Y)
      WRITE (IOUT,1062) X, Y, Z
      WRITE (IOUT,1053) XMIN, XMAX
      Z = QATAN2(XMIN,XMAX)
      WRITE (IOUT,1062) XMIN, XMAX, Z
      WRITE (IOUT,1053) XMAX, XMIN
      Z = QATAN2(XMAX,XMIN)
      WRITE (IOUT,1062) XMAX, XMIN, Z
      X = ZERO
      WRITE (IOUT,1054) X, Y
      Z = QATAN2(X,Y)
      WRITE (IOUT,1062) X, Y, Z
      WRITE (IOUT,1100)
      RETURN
 1000 FORMAT(46H1TEST OF QATAN(X) VS TRUNCATED TAYLOR SERIES  //)
 1001 FORMAT(21H1TEST OF QATAN(X) VS ,
     X  41HQATAN(1/16) + QATAN((X-1/16)/(1+X/16))    //)
 1002 FORMAT(44H1TEST OF 2*QATAN(X) VS QATAN(2X/(1-X*X))    //)
 1010 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,1H(,D15.4,1H,,D15.4,1H)//)
 1011 FORMAT(20H QATAN(X) WAS LARGER,I6,7H TIMES,/
     X    13X,7H AGREED,I6,11H TIMES, AND /
     X   9X,11HWAS SMALLER,I6,7H TIMES.//)
 1020 FORMAT(10H THERE ARE,I4,5H BASE,I4,
     X    46H SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER  //)
 1021 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6)
 1022 FORMAT(27H THE ESTIMATED LOSS OF BASE,I4,
     X  22H SIGNIFICANT DIGITS IS,F7.2//)
 1023 FORMAT(40H THE ROOT MEAN SQUARE RELATIVE ERROR WAS,D15.4,
     X    3H = ,I4,3H **,F7.2)
 1025 FORMAT(14H1SPECIAL TESTS//)
 1030 FORMAT(55H THE IDENTITY   QATAN(-X) = -QATAN(X)   WILL BE TESTED./
     X/
     X      8X,1HX,9X,12HF(X) + F(-X)/)
 1031 FORMAT(53H THE IDENTITY QATAN(X) = X , X SMALL, WILL BE TESTED.//
     X       8X,1HX,9X,8HX - F(X)/)
 1032 FORMAT(54H THE IDENTITY QATAN(X/Y) = QATAN2(X,Y) WILL BE TESTED /
     X 57H THE FIRST COLUMN OF RESULTS SHOULD BE 0, THE SECOND +-PI//
     X 8X,1HX,13X,1HY,7X,15HF1(X/Y)-F2(X,Y),5X,18HF1(X/Y)-F2(X/(-Y)) /)
 1035 FORMAT(43H TEST OF UNDERFLOW FOR VERY SMALL ARGUMENT. /)
 1050 FORMAT(22H1TEST OF ERROR RETURNS //)
 1051 FORMAT(39H QATAN WILL BE CALLED WITH THE ARGUMENT,D15.7/
     X       41H THIS SHOULD NOT TRIGGER AN ERROR MESSAGE/)
 1053 FORMAT(41H QATAN2 WILL BE CALLED WITH THE ARGUMENTS/2D15.7/
     X       41H THIS SHOULD NOT TRIGGER AN ERROR MESSAGE/)
 1054 FORMAT(41H QATAN2 WILL BE CALLED WITH THE ARGUMENTS/2D15.7/
     X       37H THIS SHOULD TRIGGER AN ERROR MESSAGE//)
 1059 FORMAT(2D15.7,2D25.17/)
 1060 FORMAT(D15.7,D25.17/)
 1061 FORMAT(6X,7H QATAN(,D13.6,3H) =,D13.6/)
 1062 FORMAT(6X,8H QATAN2(,2D13.6,3H) =,D13.6/)
 1100 FORMAT(25H THIS CONCLUDES THE TESTS )
C     ---------- LAST CARD OF QATAN/QATAN2 TEST PROGRAM ----------
      END
      SUBROUTINE  TQEXP (IOUT)
C     PROGRAM TO TEST QEXP
C
C     DATA REQUIRED
C
C        NONE
C
C     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
C
C        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
C                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
C                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
C                 BE DELETED PROVIDED THE FOLLOWING FOUR
C                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
C
C                 IBETA - THE RADIX OF THE FLOATING-POINT SYSTEM
C                 IT    - THE NUMBER OF BASE-IBETA DIGITS IN THE
C                         SIGNIFICAND OF A FLOATING-POINT NUMBER
C                 XMIN  - THE SMALLEST NON-VANISHING FLOATING-POINT
C                         POWER OF THE RADIX
C                 XMAX  - THE LARGEST FINITE FLOATING-POINT NO.
C
C        QRAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1)
C
C
C     STANDARD FORTRAN SUBPROGRAMS REQUIRED
C
C         QABS, AINT, QLOG, QMAX1, QEXP, QFLOAT, QSQRT, SNGL
C
C
C     LATEST REVISION - DECEMBER 6, 1979
C
C     AUTHOR - W. J. CODY
C              ARGONNE NATIONAL LABORATORY
C
C
      INTEGER I,IBETA,IEXP,IOUT,IRND,IT,I1,J,K1,K2,K3,MACHEP,
     X        MAXEXP,MINEXP,N,NEGEP,NGRD
      REAL*16 A,AIT,ALBETA,B,BETA,D,DEL,EPS,EPSNEG,ONE,QRAN,R6,     R7,
     X     TWO,TEN,V,W,X,XL,XMAX,XMIN,XN,X1,Y,Z,ZERO,ZZ
C
C     IOUT = 6
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      BETA = QEXT(FLOAT(IBETA))
      ALBETA = QLOG(BETA)
      AIT = QEXT(FLOAT(IT))
      ONE = 1.0Q+00
      TWO = 2.0Q+00
      TEN = 10.0Q+00
      ZERO = 0.0Q+00
      V = 0.0625Q+00
      A = TWO
      B = QLOG(A) * 0.5Q+00
      A = -B + V
      D = QLOG(0.9Q+00*XMAX)
      N = 2000
      XN = QEXT(FLOAT(N))
      I1 = 0
C---------------------------------------------------------------------
C     RANDOM ARGUMENT ACCURACY TESTS
C---------------------------------------------------------------------
      DO 300 J = 1, 3
         K1 = 0
         K3 = 0
         X1 = ZERO
         R6 = ZERO
         R7 = ZERO
         DEL = (B - A) / XN
         XL = A
C
         DO 200 I = 1, N
            X = DEL * QRAN(I1) + XL
C---------------------------------------------------------------------
C     PURIFY ARGUMENTS
C---------------------------------------------------------------------
            Y = X - V
            IF (Y .LT. ZERO) X = Y + V
            Z = QEXP(X)
            ZZ = QEXP(Y)
            IF (J .EQ. 1) GO TO 100
C#          IF (IBETA .NE. 10) Z = Z * 0.0625D+00 -
C#   1                             Z * 2.4453321046920570389D-3
C#          IF (IBETA .NE. 10) Z = Z * 0.0625D+00 - Z *
C#   1           (0.0625 - 1/EXP(45/16))
            IF (IBETA .NE. 10) Z = Z * 0.0625Q+00 - Z *
     X      2.445332104692057038944386692209648655994744180777192315Q-03
C#          IF (IBETA .EQ. 10) Z = Z * 6.0D-2 +
C#   1                             Z * 5.466789530794296106D-5
C#          IF (IBETA .EQ. 10) Z = Z * 6.0D-2 + Z *
C#   X           (1/EXP(45/16) - 0.06)
            IF (IBETA .EQ. 10) Z = Z * 6.0Q-2 + Z *
     X      5.46678953079429610556133077903513440052558192228076851Q-05
            GO TO 110
C#100       Z = Z - Z * 6.058693718652421388D-2
C#          Z = Z - Z * (1 - 1/EXP(1/16))
  100       Z = Z - Z *
     X      6.058693718652421388028917537769491547531910945055817799Q-02
  110       W = ONE
            IF (ZZ .NE. ZERO) W = (Z - ZZ) / ZZ
            IF (W .LT. ZERO) K1 = K1 + 1
            IF (W .GT. ZERO) K3 = K3 + 1
            W = QABS(W)
            IF (W .LE. R6) GO TO 120
            R6 = W
            X1 = X
  120       R7 = R7 + W*W
            XL = XL + DEL
  200    CONTINUE
C
         K2 = N - K3 - K1
         R7 = QSQRT(R7/XN)
         WRITE (IOUT,1000) V, V
         WRITE (IOUT,1010) N,A,B
         WRITE (IOUT,1011) K1,K2,K3
         WRITE (IOUT,1020) IT,IBETA
         W = -999.0Q+00
         IF (R6 .NE. ZERO) W = QLOG(QABS(R6))/ALBETA
         WRITE (IOUT,1021) R6,IBETA,W,X1
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         W = -999.0Q+00
         IF (R7 .NE. ZERO) W = QLOG(QABS(R7))/ALBETA
         WRITE (IOUT,1023) R7,IBETA,W
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         IF (J .EQ. 2) GO TO 270
         V = 45.0Q+00 / 16.0Q+00
         A = -TEN * B
         B = 4.0Q+00 * XMIN * BETA ** IT
         B = QLOG(B)
         GO TO 300
  270    A = -TWO * A
         B = TEN * A
         IF (B .LT. D) B = D
  300 CONTINUE
C---------------------------------------------------------------------
C     SPECIAL TESTS
C---------------------------------------------------------------------
      WRITE (IOUT,1025)
      WRITE (IOUT,1030)
C
      DO 320 I = 1, 5
         X = QRAN(I1) * BETA
         Y = -X
         Z = QEXP(X) * QEXP(Y) - ONE
         WRITE (IOUT,1060) X, Z
  320 CONTINUE
C
      WRITE (IOUT,1040)
      X = ZERO
      Y = QEXP(X) - ONE
      WRITE (IOUT,1041) Y
      X = IQINT(QLOG(XMIN))
      Y = QEXP(X)
      WRITE (IOUT,1042) X, Y
      X = IQINT(QLOG(XMAX))
      Y = QEXP(X)
      WRITE (IOUT,1042) X, Y
      X = X / TWO
      V = X / TWO
      Y = QEXP(X)
      Z = QEXP (V)
      Z = Z * Z
      WRITE (IOUT,1043) X, Y, V, Z
C---------------------------------------------------------------------
C     TEST OF ERROR RETURNS
C---------------------------------------------------------------------
      WRITE (IOUT,1050)
      X = -ONE / QSQRT(XMIN)
      WRITE (IOUT,1052) X
      Y = QEXP(X)
      WRITE (IOUT,1061) Y
      X = -X
      WRITE (IOUT,1052) X
      Y = QEXP(X)
      WRITE (IOUT,1061) Y
      WRITE (IOUT,1100)
      RETURN
 1000 FORMAT(16H1TEST OF QEXP(X-,F7.4,18H) VS QEXP(X)/QEXP(,F7.4,1H) //)
 1010 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,1H(,D15.4,1H,,D15.4,1H)//)
 1011 FORMAT(21H QEXP(X-V) WAS LARGER,I6,7H TIMES, /
     X     13X,7H AGREED,I6,11H TIMES, AND /
     X   9X,11HWAS SMALLER,I6,7H TIMES.//)
 1020 FORMAT(10H THERE ARE,I4,5H BASE,I4,
     X    46H SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER  //)
 1021 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6)
 1022 FORMAT(27H THE ESTIMATED LOSS OF BASE,I4,
     X  22H SIGNIFICANT DIGITS IS,F7.2//)
 1023 FORMAT(40H THE ROOT MEAN SQUARE RELATIVE ERROR WAS,D15.4,
     X    3H = ,I4,3H **,F7.2)
 1025 FORMAT(14H1SPECIAL TESTS//)
 1030 FORMAT(54H THE IDENTITY  QEXP(X)*QEXP(-X) = 1.0  WILL BE TESTED.//
     X      8X,1HX,9X,14HF(X)*F(-X) - 1 /)
 1040 FORMAT(//26H TEST OF SPECIAL ARGUMENTS //)
 1041 FORMAT(23H QEXP(0.0) - 1.0D+00 = ,D15.7/)
 1042 FORMAT(6H QEXP(,D13.6,3H) =,D13.6/)
 1043 FORMAT(9H0IF QEXP(,D13.6,4H) = ,D23.16,13H IS NOT ABOUT /
     X 6H QEXP(,D13.6,7H)**2 = ,D23.16,26H THERE IS AN ARG RED ERROR)
 1050 FORMAT(22H1TEST OF ERROR RETURNS  //)
 1052 FORMAT(37H0EXP WILL BE CALLED WITH THE ARGUMENT,D15.4/
     X       37H THIS SHOULD TRIGGER AN ERROR MESSAGE//)
 1060 FORMAT(D15.7,D25.17/)
 1061 FORMAT(24H QEXP RETURNED THE VALUE,D15.4///)
 1100 FORMAT(25H THIS CONCLUDES THE TESTS )
C     ---------- LAST CARD OF QEXP TEST PROGRAM ----------
      END
      SUBROUTINE  TQLOG (IOUT)
C     PROGRAM TO TEST QLOG
C
C     DATA REQUIRED
C
C        NONE
C
C     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
C
C        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
C                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
C                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
C                 BE DELETED PROVIDED THE FOLLOWING FOUR
C                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
C
C                 IBETA - THE RADIX OF THE FLOATING-POINT SYSTEM
C                 IT    - THE NUMBER OF BASE-IBETA DIGITS IN THE
C                         SIGNIFICAND OF A FLOATING-POINT NUMBER
C                 XMIN  - THE SMALLEST NON-VANISHING FLOATING-POINT
C                         POWER OF THE RADIX
C                 XMAX  - THE LARGEST FINITE FLOATING-POINT NO.
C
C        QRAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1)
C
C
C     STANDARD FORTRAN SUBPROGRAMS REQUIRED
C
C         QABS, QLOG, QLOG10, QMAX1, QFLOAT, DSIGN, QSQRT
C
C
C     LATEST REVISION - DECEMBER 6, 1979
C
C     AUTHOR - W. J. CODY
C              ARGONNE NATIONAL LABORATORY
C
C
      INTEGER I,IBETA,IEXP,IOUT,IRND,IT,I1,J,K1,K2,K3,MACHEP,
     X        MAXEXP,MINEXP,N,NEGEP,NGRD
      REAL*16 A,AIT,ALBETA,B,BETA,C,DEL,EIGHT,EPS,EPSNEG,HALF,      ONE,
     X QRAN,R6,R7,TENTH,W,X,XL,XMAX,XMIN,XN,X1,Y,Z,ZERO,ZZ
C
C     IOUT = 6
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      BETA = QEXT(FLOAT(IBETA))
      ALBETA = QLOG(BETA)
      AIT = QEXT(FLOAT(IT))
      J = IT / 3
      ZERO = 0.0Q+00
      HALF = 0.5Q+00
      EIGHT = 8.0Q+00
      TENTH = 0.1Q+00
      ONE = 1.0Q+00
      C = ONE
C
      DO 50 I = 1, J
         C = C / BETA
   50 CONTINUE
C
      B = ONE + C
      A = ONE - C
      N = 2000
      XN = QEXT(FLOAT(N))
      I1 = 0
C-----------------------------------------------------------------
C     RANDOM ARGUMENT ACCURACY TESTS
C-----------------------------------------------------------------
      DO 300 J = 1, 4
         K1 = 0
         K3 = 0
         X1 = ZERO
         R6 = ZERO
         R7 = ZERO
         DEL = (B - A) / XN
         XL = A
C
         DO 200 I = 1, N
            X = DEL * QRAN(I1) + XL
            IF (J .NE. 1) GO TO 100
            Y = (X - HALF) - HALF
            ZZ = QLOG(X)
            Z = ONE / 3.0Q+00
            Z = Y * (Z - Y / 4.0Q+00)
            Z = (Z - HALF) * Y * Y + Y
            GO TO 150
  100       IF (J .NE. 2) GO TO 110
            X = (X + EIGHT) - EIGHT
            Y = X + X / 16.0Q+00
            Z = QLOG(X)
C#          ZZ = QLOG(Y) - 7.7746816434842581D-5
C#          ZZ = QLOG(Y) - (log(17/16) - 31/512)
            ZZ = QLOG(Y) -
     X      7.77468164348425806061320404202632862024751447237708145Q-05
            ZZ = ZZ - 31.0Q+00/512.0Q+00
            GO TO 150
  110       IF (J .NE. 3) GO TO 120
            X = (X + EIGHT) - EIGHT
            Y = X + X * TENTH
            Z = QLOG10(X)
C#          ZZ = QLOG10(Y) - 3.7706015822504075D-4
C#          ZZ = QLOG10(Y) - (log10(1.1) - 21/512)
            ZZ = QLOG10(Y) -
     X      3.770601582250407501999712430242417067021904664530945966Q-04
            ZZ = ZZ - 21.0Q+00/512.0Q+00
            GO TO 150
  120       Z = QLOG(X*X)
            ZZ = QLOG(X)
            ZZ = ZZ + ZZ
  150       W = ONE
            IF (Z .NE. ZERO) W = (Z - ZZ) / Z
            Z = QSIGN(W,Z)
            IF (Z .GT. ZERO) K1 = K1 + 1
            IF (Z .LT. ZERO) K3 = K3 + 1
            W = QABS(W)
            IF (W .LE. R6) GO TO 160
            R6 = W
            X1 = X
  160       R7 = R7 + W*W
            XL = XL + DEL
  200    CONTINUE
C
         K2 = N - K3 - K1
         R7 = QSQRT(R7/XN)
         IF (J .EQ. 1) WRITE (IOUT,1000)
         IF (J .EQ. 2) WRITE (IOUT,1001)
         IF (J .EQ. 3) WRITE (IOUT,1005)
         IF (J .EQ. 4) WRITE (IOUT,1002)
         IF (J .EQ. 1) WRITE (IOUT,1009) N,C
         IF (J .NE. 1) WRITE (IOUT,1010) N,A,B
         IF (J .NE. 3) WRITE (IOUT,1011) K1,K2,K3
         IF (J .EQ. 3) WRITE (IOUT,1012) K1,K2,K3
         WRITE (IOUT,1020) IT,IBETA
         W = -999.0Q+00
         IF (R6 .NE. ZERO) W = QLOG(QABS(R6))/ALBETA
         WRITE (IOUT,1021) R6,IBETA,W,X1
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         W = -999.0Q+00
         IF (R7 .NE. ZERO) W = QLOG(QABS(R7))/ALBETA
         WRITE (IOUT,1023) R7,IBETA,W
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         IF (J .GT. 1) GO TO 230
         A = QSQRT(HALF)
         B = 15.0Q+00 / 16.0Q+00
         GO TO 300
  230    IF (J .GT. 2) GO TO 240
         A = QSQRT(TENTH)
         B = 0.9Q+00
         GO TO 300
  240    A = 16.0Q+00
         B = 240.0Q+00
  300 CONTINUE
C-----------------------------------------------------------------
C     SPECIAL TESTS
C-----------------------------------------------------------------
      WRITE (IOUT,1025)
      WRITE (IOUT,1030)
C
      DO 320 I = 1, 5
         X = QRAN(I1)
         X = X + X + 15.0Q+00
         Y = ONE / X
         Z = QLOG(X) + QLOG(Y)
         WRITE (IOUT,1060) X, Z
  320 CONTINUE
C
      WRITE (IOUT,1040)
      X = ONE
      Y = QLOG(X)
      WRITE (IOUT,1041) Y
      X = XMIN
      Y = QLOG(X)
      WRITE (IOUT,1042) X, Y
      X = XMAX
      Y = QLOG(X)
      WRITE (IOUT,1043) X, Y
C-----------------------------------------------------------------
C     TEST OF ERROR RETURNS
C-----------------------------------------------------------------
      WRITE (IOUT,1050)
      X = -2.0Q+00
      WRITE (IOUT,1052) X
      Y = QLOG(X)
      WRITE (IOUT,1055) Y
      X = ZERO
      WRITE (IOUT,1052) X
      Y = QLOG(X)
      WRITE (IOUT,1055) Y
      WRITE (IOUT,1100)
      RETURN
 1000 FORMAT(49H1TEST OF QLOG(X) VS T.S. EXPANSION OF QLOG(1+Y)  //)
 1001 FORMAT(47H1TEST OF QLOG(X) VS QLOG(17X/16)-QLOG(17/16)   //)
 1002 FORMAT(34H1TEST OF QLOG(X*X) VS 2 * LOG(X)  //)
 1005 FORMAT(51H1TEST OF QLOG10(X) VS QLOG10(11X/10)-QLOG10(11/10) //)
 1009 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,26H(1-EPS,1+EPS), WHERE EPS =, D15.4//)
 1010 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,1H(,D15.4,1H,,D15.4,1H)//)
 1011 FORMAT(19H QLOG(X) WAS LARGER,I6,7H TIMES, /
     X     12X,7H AGREED,I6,11H TIMES, AND /
     X     8X,11HWAS SMALLER,I6,7H TIMES.//)
 1012 FORMAT(21H QLOG10(X) WAS LARGER,I6,7H TIMES, /
     X     14X,7H AGREED,I6,11H TIMES, AND /
     X     10X,11HWAS SMALLER,I6,7H TIMES.//)
 1020 FORMAT(10H THERE ARE,I4,5H BASE,I4,
     X    46H SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER  //)
 1021 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6)
 1022 FORMAT(27H THE ESTIMATED LOSS OF BASE,I4,
     X  22H SIGNIFICANT DIGITS IS,F7.2//)
 1023 FORMAT(40H THE ROOT MEAN SQUARE RELATIVE ERROR WAS,D15.4,
     X    3H = ,I4,3H **,F7.2)
 1025 FORMAT(14H1SPECIAL TESTS//)
 1030 FORMAT(52H THE IDENTITY  QLOG(X) = -QLOG(1/X)  WILL BE TESTED.//
     X      8X,1HX,9X,13HF(X) + F(1/X)/)
 1040 FORMAT(//26H TEST OF SPECIAL ARGUMENTS //)
 1041 FORMAT(13H QLOG(1.0) = ,D25.17//)
 1042 FORMAT(19H QLOG(XMIN) = QLOG(,D25.17,4H) = ,D25.17//)
 1043 FORMAT(19H QLOG(XMAX) = QLOG(,D25.17,4H) = ,D25.17//)
 1050 FORMAT(22H1TEST OF ERROR RETURNS//)
 1052 FORMAT(38H QLOG WILL BE CALLED WITH THE ARGUMENT,D15.4/
     X       37H THIS SHOULD TRIGGER AN ERROR MESSAGE//)
 1055 FORMAT(24H QLOG RETURNED THE VALUE,D15.4///)
 1060 FORMAT(D15.7,D25.17/)
 1100 FORMAT(25H THIS CONCLUDES THE TESTS )
C     ---------- LAST CARD OF QLOG/QLOG10 TEST PROGRAM ----------
      END
      SUBROUTINE  TPOWER (IOUT)
C     PROGRAM TO TEST POWER FUNCTION (**)
C
C     DATA REQUIRED
C
C        NONE
C
C     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
C
C        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
C                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
C                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
C                 BE DELETED PROVIDED THE FOLLOWING SIX
C                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
C
C                 IBETA  - THE RADIX OF THE FLOATING-POINT SYSTEM
C                 IT     - THE NUMBER OF BASE-IBETA DIGITS IN THE
C                          SIGNIFICAND OF A FLOATING-POINT NUMBER
C                 MINEXP - THE LARGEST IN MAGNITUDE NEGATIVE
C                          INTEGER SUCH THAT  QFLOAT(IBETA)**MINEXP
C                          IS A POSITIVE FLOATING-POINT NUMBER
C                 MAXEXP - THE LARGEST POSITIVE INTEGER EXPONENT
C                          FOR A FINITE FLOATING-POINT NUMBER
C                 XMIN   - THE SMALLEST NON-VANISHING FLOATING-POINT
C                          POWER OF THE RADIX
C                 XMAX   - THE LARGEST FINITE FLOATING-POINT
C                          NUMBER
C
C        QRAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1)
C
C
C     STANDARD FORTRAN SUBPROGRAMS REQUIRED
C
C         QABS, QLOG, QMAX1, QEXP, QFLOAT, QSQRT
C
C
C     LATEST REVISION - DECEMBER 6, 1979
C
C     AUTHOR - W. J. CODY
C              ARGONNE NATIONAL LABORATORY
C
C
      INTEGER I,IBETA,IEXP,IOUT,IRND,IT,I1,J,K1,K2,K3,MACHEP,
     X        MAXEXP,MINEXP,N,NEGEP,NGRD
      REAL*16 A,AIT,ALBETA,ALXMAX,B,BETA,C,DEL,DELY,EPS,EPSNEG,     ONE,
     X     ONEP5,QRAN,R6,R7,SCALE,TWO,W,X,XL,XMAX,XMIN,XN,XSQ,X1,Y,
     X Y1,Y2,Z,ZERO,ZZ
      REAL*16 STORE
C
C     IOUT = 6
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      BETA = QEXT(FLOAT(IBETA))
      ALBETA = QLOG(BETA)
      AIT = QEXT(FLOAT(IT))
      ALXMAX = QLOG(XMAX)
      ZERO = 0.0Q+00
      ONE = QEXT(FLOAT(1))
      TWO = ONE + ONE
      ONEP5 = (TWO + ONE) / TWO
      SCALE = ONE
      J = (IT+1) / 2
C
      DO 20 I = 1, J
         SCALE = SCALE * BETA
   20 CONTINUE
C
      A = ONE / BETA
      B = ONE
      C = -QMAX1(ALXMAX,-QLOG(XMIN))/QLOG(100Q+00)
      DELY = -C - C
      N = 2000
      XN = QEXT(FLOAT(N))
      I1 = 0
      Y1 = ZERO
C-----------------------------------------------------------------
C     RANDOM ARGUMENT ACCURACY TESTS
C-----------------------------------------------------------------
      DO 300 J = 1, 4
         K1 = 0
         K3 = 0
         X1 = ZERO
         R6 = ZERO
         R7 = ZERO
         DEL = (B - A) / XN
         XL = A
C
         DO 200 I = 1, N
            X = DEL * QRAN(I1) + XL
            IF (J .NE. 1) GO TO 50
            ZZ = X ** ONE
            Z = X
            GO TO 110
   50       W = STORE(SCALE * X)
            X = STORE(STORE(X + W) - W)
            XSQ = X * X
            IF (J .EQ. 4) GO TO 70
            ZZ = XSQ ** ONEP5
            Z = X * XSQ
            GO TO 110
   70       Y = DELY * QRAN(I1) + C
            Y2 = (Y/TWO + Y) - Y
            Y = Y2 + Y2
            Z = X ** Y
            ZZ = XSQ ** Y2
  110       W = ONE
            IF (Z .NE. ZERO) W = (Z - ZZ) / Z
            IF (W .GT. ZERO) K1 = K1 + 1
            IF (W .LT. ZERO) K3 = K3 + 1
            W = QABS(W)
            IF (W .LE. R6) GO TO 120
            R6 = W
            X1 = X
            IF (J .EQ. 4) Y1 = Y
  120       R7 = R7 + W * W
            XL = XL + DEL
  200    CONTINUE
C
         K2 = N - K3 - K1
         R7 = QSQRT(R7/XN)
         IF (J .GT. 1) GO TO 210
         WRITE (IOUT,1000)
         WRITE (IOUT,1010) N,A,B
         WRITE (IOUT,1011) K1,K2,K3
         GO TO 220
  210    IF (J .EQ. 4) GO TO 215
         WRITE (IOUT,1001)
         WRITE (IOUT,1010) N,A,B
         WRITE (IOUT,1012) K1,K2,K3
         GO TO 220
  215    WRITE (IOUT,1002)
         W = C + DELY
         WRITE (IOUT,1014) N,A,B,C,W
         WRITE (IOUT,1013) K1,K2,K3
  220    WRITE (IOUT,1020) IT,IBETA
         W = -999.0Q+00
         IF (R6 .NE. ZERO) W = QLOG(QABS(R6))/ALBETA
         IF (J .NE. 4) WRITE (IOUT,1021) R6,IBETA,W,X1
         IF (J .EQ. 4) WRITE (IOUT,1024) R6,IBETA,W,X1,Y1
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         W = -999.0Q+00
         IF (R7 .NE. ZERO) W = QLOG(QABS(R7))/ALBETA
         WRITE (IOUT,1023) R7,IBETA,W
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         IF (J .EQ. 1) GO TO 300
         B = 10.0Q+00
         A = 0.01Q+00
         IF (J .EQ. 3) GO TO 300
         A = ONE
         B = QEXP(ALXMAX/3.0Q+00)
  300 CONTINUE
C-----------------------------------------------------------------
C     SPECIAL TESTS
C-----------------------------------------------------------------
      WRITE (IOUT,1025)
      WRITE (IOUT,1030)
      B = 10.0Q+00
C
      DO 320 I = 1, 5
         X = QRAN(I1) * B + ONE
         Y = QRAN(I1) * B + ONE
         Z = X ** Y
         ZZ = (ONE/X) ** (-Y)
         W = (Z - ZZ) / Z
         WRITE (IOUT,1060) X, Y, W
  320 CONTINUE
C-----------------------------------------------------------------
C     TEST OF ERROR RETURNS
C-----------------------------------------------------------------
      WRITE (IOUT,1050)
      X = BETA
      Y = QEXT(FLOAT(MINEXP))
      WRITE (IOUT,1051) X, Y
      Z = X ** Y
      WRITE (IOUT,1055) Z
      Y = QEXT(FLOAT(MAXEXP-1))
      WRITE (IOUT,1051) X, Y
      Z = X ** Y
      WRITE (IOUT,1055) Z
      X = ZERO
      Y = TWO
      WRITE (IOUT,1051) X, Y
      Z = X ** Y
      WRITE (IOUT,1055) Z
      X = -Y
      Y = ZERO
      WRITE (IOUT,1052) X, Y
      Z = X ** Y
      WRITE (IOUT,1055) Z
      Y = TWO
      WRITE (IOUT,1052) X, Y
      Z = X ** Y
      WRITE (IOUT,1055) Z
      X = ZERO
      Y = ZERO
      WRITE (IOUT,1052) X, Y
      Z = X ** Y
      WRITE (IOUT,1055) Z
      WRITE (IOUT,1100)
      RETURN
 1000 FORMAT(20H1TEST OF X**1.0 VS X  //)
 1001 FORMAT(26H1TEST OF XSQ**1.5 VS XSQ*X  //)
 1002 FORMAT(27H1TEST OF X**Y VS XSQ**(Y/2)  //)
 1010 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,1H(,D15.4,1H,,D15.4,1H)//)
 1011 FORMAT(18H X**1.0 WAS LARGER,I6,7H TIMES, /
     X     11X,7H AGREED,I6,11H TIMES, AND /
     X   7X,11HWAS SMALLER,I6,7H TIMES.//)
 1012 FORMAT(18H X**1.5 WAS LARGER,I6,7H TIMES, /
     X     11X,7H AGREED,I6,11H TIMES, AND /
     X   7X,11HWAS SMALLER,I6,7H TIMES.//)
 1013 FORMAT(18H  X**Y  WAS LARGER,I6,7H TIMES, /
     X     11X,7H AGREED,I6,11H TIMES, AND /
     X   7X,11HWAS SMALLER,I6,7H TIMES.//)
 1014 FORMAT(I7,45H RANDOM ARGUMENTS WERE TESTED FROM THE REGION /
     X 6X,6HX IN (,D15.4,1H,,D15.4,9H), Y IN (,D15.4,1H,,D15.4,1H)//)
 1020 FORMAT(10H THERE ARE,I4,5H BASE,I4,
     X    46H SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER  //)
 1021 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6)
 1022 FORMAT(27H THE ESTIMATED LOSS OF BASE,I4,
     X  22H SIGNIFICANT DIGITS IS,F7.2//)
 1023 FORMAT(40H THE ROOT MEAN SQUARE RELATIVE ERROR WAS,D15.4,
     X    3H = ,I4,3H **,F7.2)
 1024 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6,4H Y =,D17.6)
 1025 FORMAT(14H1SPECIAL TESTS//)
 1030 FORMAT(54H THE IDENTITY  X ** Y = (1/X) ** (-Y)  WILL BE TESTED.
     X    //8X,1HX,14X,1HY,9X,24H(X**Y-(1/X)**(-Y) / X**Y /)
 1050 FORMAT(22H1TEST OF ERROR RETURNS//)
 1051 FORMAT(2H (,D14.7,7H ) ** (,D14.7,20H ) WILL BE COMPUTED./
     X       41H THIS SHOULD NOT TRIGGER AN ERROR MESSAGE//)
 1052 FORMAT(2H (,D14.7,7H ) ** (,D14.7,20H ) WILL BE COMPUTED./
     X       37H THIS SHOULD TRIGGER AN ERROR MESSAGE//)
 1055 FORMAT(22H THE VALUE RETURNED IS,D15.4///)
 1060 FORMAT(2D15.7,6X,D15.7/)
 1100 FORMAT(25H THIS CONCLUDES THE TESTS )
C     ---------- LAST CARD OF POWER TEST PROGRAM ----------
      END
      SUBROUTINE  TQSIN (IOUT)
C     PROGRAM TO TEST QSIN/QCOS
C
C     DATA REQUIRED
C
C        NONE
C
C     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
C
C        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
C                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
C                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
C                 BE DELETED PROVIDED THE FOLLOWING FIVE
C                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
C
C                 IBETA  - THE RADIX OF THE FLOATING-POINT SYSTEM
C                 IT     - THE NUMBER OF BASE-IBETA DIGITS IN THE
C                          SIGNIFICAND OF A FLOATING-POINT NUMBER
C                 MINEXP - THE LARGEST IN MAGNITUDE NEGATIVE
C                          INTEGER SUCH THAT  QFLOAT(IBETA)**MINEXP
C                          IS A POSITIVE FLOATING-POINT NUMBER
C                 EPS    - THE SMALLEST POSITIVE FLOATING-POINT
C                          NUMBER SUCH THAT 1.0+EPS .NE. 1.0
C                 EPSNEG - THE SMALLEST POSITIVE FLOATING-POINT
C                          NUMBER SUCH THAT 1.0-EPSNEG .NE. 1.0
C
C        QRAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1)
C
C
C     STANDARD FORTRAN SUBPROGRAMS REQUIRED
C
C         QABS, QLOG, QMAX1, QCOS, QFLOAT, QSIN, QSQRT
C
C
C     LATEST REVISION - DECEMBER 6, 1979
C
C     AUTHOR - W. J. CODY
C              ARGONNE NATIONAL LABORATORY
C
C
      INTEGER I,IBETA,IEXP,IOUT,IRND,IT,I1,J,K1,K2,K3,MACHEP,
     X        MAXEXP,MINEXP,N,NEGEP,NGRD
      REAL*16 A,AIT,ALBETA,B,BETA,BETAP,C,DEL,EPS,EPSNEG,EXPON,     ONE,
     X     QRAN, R6,R7,THREE,W,X,XL,XMAX,XMIN,XN,X1,Y,Z,ZERO,ZZ
C
C     IOUT = 6
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      BETA = QEXT(FLOAT(IBETA))
      ALBETA = QLOG(BETA)
      AIT = QEXT(FLOAT(IT))
      ONE = 1.0Q+00
      ZERO = 0.0Q+00
      THREE = 3.0Q+00
      A = ZERO
C#    B = 1.570796327D+00
C#    B = PI/2
      B = 1.57079632679489661923132169163975144209858469968755291Q+00
      C = B
      N = 2000
      XN = QEXT(FLOAT(N))
      I1 = 0
C-----------------------------------------------------------------
C     RANDOM ARGUMENT ACCURACY TESTS
C-----------------------------------------------------------------
      DO 300 J = 1, 3
         K1 = 0
         K3 = 0
         X1 = ZERO
         R6 = ZERO
         R7 = ZERO
         DEL = (B - A) / XN
         XL = A
C
         DO 200 I = 1, N
            X = DEL * QRAN(I1) + XL
            Y = X / THREE
            Y = (X + Y) - X
            X = THREE * Y
            IF (J .EQ. 3) GO TO 100
            Z = QSIN(X)
            ZZ = QSIN(Y)
            W = ONE
            IF (Z .NE. ZERO) W = (Z - ZZ*(THREE-4.0Q+00*ZZ*ZZ)) / Z
            GO TO 110
  100       Z = QCOS(X)
            ZZ = QCOS(Y)
            W = ONE
            IF (Z .NE. ZERO) W = (Z + ZZ*(THREE-4.0Q+00*ZZ*ZZ)) / Z
  110       IF (W .GT. ZERO) K1 = K1 + 1
            IF (W .LT. ZERO) K3 = K3 + 1
            W = QABS(W)
            IF (W .LE. R6) GO TO 120
            R6 = W
            X1 = X
  120       R7 = R7 + W * W
            XL = XL + DEL
  200    CONTINUE
C
         K2 = N - K3 - K1
         R7 = QSQRT(R7/XN)
         IF (J .EQ. 3) GO TO 210
         WRITE (IOUT,1000)
         WRITE (IOUT,1010) N,A,B
         WRITE (IOUT,1011) K1,K2,K3
         GO TO 220
  210    WRITE (IOUT,1005)
         WRITE (IOUT,1010) N,A,B
         WRITE (IOUT,1012) K1,K2,K3
  220    WRITE (IOUT,1020) IT,IBETA
         W = -999.0Q+00
         IF (R6 .NE. ZERO) W = QLOG(QABS(R6))/ALBETA
         WRITE (IOUT,1021) R6,IBETA,W,X1
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         W = -999.0Q+00
         IF (R7 .NE. ZERO) W = QLOG(QABS(R7))/ALBETA
         WRITE (IOUT,1023) R7,IBETA,W
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
C#       A = 18.84955592D+00
C#       A = 6*PI
         A =
     X   18.84955592153875943077586029967701730518301639625063493Q+00
         IF (J .EQ. 2) A = B + C
         B = A + C
  300 CONTINUE
C-----------------------------------------------------------------
C     SPECIAL TESTS
C-----------------------------------------------------------------
      WRITE (IOUT,1025)
      C = ONE / BETA ** (IT/2)
      Z = (QSIN(A+C) - QSIN(A-C)) / (C + C)
      WRITE (IOUT,1026) Z
C
      WRITE (IOUT,1030)
C
      DO 320 I = 1, 5
         X = QRAN(I1) * A
         Z = QSIN(X) + QSIN(-X)
         WRITE (IOUT,1060) X, Z
  320 CONTINUE
C
      WRITE (IOUT,1031)
      BETAP = BETA ** IT
      X = QRAN(I1) / BETAP
C
      DO 330 I = 1, 5
         Z = X - QSIN(X)
         WRITE (IOUT,1060) X, Z
         X = X / BETA
  330 CONTINUE
C
      WRITE (IOUT,1032)
C
      DO 340 I = 1, 5
         X = QRAN(I1) * A
         Z = QCOS(X) - QCOS(-X)
         WRITE (IOUT,1060) X, Z
  340 CONTINUE
C
      WRITE (IOUT,1035)
      EXPON = QEXT(FLOAT(MINEXP)) * 0.75Q+00
      X = BETA ** EXPON
      Y = QSIN(X)
      WRITE (IOUT,1061) X, Y
      WRITE (IOUT,1040)
      Z = QSQRT(BETAP)
      X = Z * (ONE - EPSNEG)
      Y = QSIN(X)
      WRITE (IOUT,1061) X, Y
      Y = QSIN(Z)
      WRITE (IOUT,1061) Z, Y
      X = Z * (ONE + EPS)
      Y = QSIN(X)
      WRITE (IOUT,1061) X, Y
C-----------------------------------------------------------------
C     TEST OF ERROR RETURNS
C-----------------------------------------------------------------
      WRITE (IOUT,1050)
      X = BETAP
      WRITE (IOUT,1052) X
      Y = QSIN(X)
      WRITE (IOUT,1055) Y
      WRITE (IOUT,1100)
      RETURN
 1000 FORMAT(48H1TEST OF QSIN(X) VS 3*QSIN(X/3)-4*QSIN(X/3)**3  //)
 1005 FORMAT(48H1TEST OF QCOS(X) VS 4*QCOS(X/3)**3-3*QCOS(X/3)  //)
 1010 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,1H(,D15.4,1H,,D15.4,1H)//)
 1011 FORMAT(19H QSIN(X) WAS LARGER,I6,7H TIMES, /
     X     11X,7H AGREED,I6,11H TIMES, AND /
     X   7X,11HWAS SMALLER,I6,7H TIMES.//)
 1012 FORMAT(19H QCOS(X) WAS LARGER,I6,7H TIMES, /
     X     11X,7H AGREED,I6,11H TIMES, AND /
     X   7X,11HWAS SMALLER,I6,7H TIMES.//)
 1020 FORMAT(10H THERE ARE,I4,5H BASE,I4,
     X    46H SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER  //)
 1021 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6)
 1022 FORMAT(27H THE ESTIMATED LOSS OF BASE,I4,
     X  22H SIGNIFICANT DIGITS IS,F7.2//)
 1023 FORMAT(40H THE ROOT MEAN SQUARE RELATIVE ERROR WAS,D15.4,
     X    3H = ,I4,3H **,F7.2)
 1025 FORMAT(14H1SPECIAL TESTS//)
 1026 FORMAT(4H IF ,D13.6,23H IS NOT ALMOST 1.0D+00,,
     X   4X,28HQSIN HAS THE WRONG PERIOD.  //)
 1030 FORMAT(53H THE IDENTITY   QSIN(-X) = -QSIN(X)   WILL BE TESTED.//
     X      8X,1HX,9X,12HF(X) + F(-X)/)
 1031 FORMAT(52H THE IDENTITY QSIN(X) = X , X SMALL, WILL BE TESTED.//
     X       8X,1HX,9X,8HX - F(X)/)
 1032 FORMAT(52H THE IDENTITY   QCOS(-X) = QCOS(X)   WILL BE TESTED.//
     X      8X,1HX,9X,12HF(X) - F(-X)/)
 1035 FORMAT(43H TEST OF UNDERFLOW FOR VERY SMALL ARGUMENT.)
 1040 FORMAT(49H THE FOLLOWING THREE LINES ILLUSTRATE THE LOSS IN,
     X  13H SIGNIFICANCE/36H FOR LARGE ARGUMENTS.  THE ARGUMENTS,
     X  17H ARE CONSECUTIVE.)
 1050 FORMAT(22H1TEST OF ERROR RETURNS//)
 1052 FORMAT(38H QSIN WILL BE CALLED WITH THE ARGUMENT,D15.4/
     X       37H THIS SHOULD TRIGGER AN ERROR MESSAGE//)
 1055 FORMAT(24H QSIN RETURNED THE VALUE,D15.4///)
 1060 FORMAT(D15.7,D25.17/)
 1061 FORMAT(/6X,6H QSIN(,D23.16,3H) =,D23.16)
 1100 FORMAT(25H THIS CONCLUDES THE TESTS )
C     ---------- LAST CARD OF QSIN/QCOS TEST PROGRAM ----------
      END
      SUBROUTINE  TQSINH (IOUT)
C     PROGRAM TO TEST QSINH/QCOSH
C
C     DATA REQUIRED
C
C        NONE
C
C     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
C
C        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
C                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
C                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
C                 BE DELETED PROVIDED THE FOLLOWING SIX
C                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
C
C                 IBETA  - THE RADIX OF THE FLOATING-POINT SYSTEM
C                 IT     - THE NUMBER OF BASE-IBETA DIGITS IN THE
C                          SIGNIFICAND OF A FLOATING-POINT NUMBER
C                 IRND   - 0 IF FLOATING-POINT ADDITION CHOPS,
C                          1 IF FLOATING-POINT ADDITION ROUNDS
C                 MINEXP - THE LARGEST IN MAGNITUDE NEGATIVE
C                          INTEGER SUCH THAT QFLOAT(IBETA)**MINEXP
C                          IS A POSITIVE FLOATING-POINT NUMBER
C                 EPS    - THE SMALLEST POSITIVE FLOATING-POINT
C                          NUMBER SUCH THAT 1.0+EPS .NE. 1.0
C                 XMAX   - THE LARGEST FINITE FLOATING-POINT NO.
C
C        QRAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1)
C
C
C     STANDARD FORTRAN SUBPROGRAMS REQUIRED
C
C         QABS, QLOG, QMAX1, QCOSH, QFLOAT, IDINT, QSINH, QSQRT
C
C
C     LATEST REVISION - DECEMBER 6, 1979
C
C     AUTHOR - W. J. CODY
C              ARGONNE NATIONAL LABORATORY
C
C
      INTEGER I,IBETA,IEXP,II,IOUT,IRND,IT,I1,I2,J,K1,K2,K3,
     X        MACHEP,MAXEXP,MINEXP,N,NEGEP,NGRD,NIT
      REAL*16 A,AIND,AIT,ALBETA,ALXMAX,B,BETA,BETAP,C,C0,DEL,       DEN,
     X     EPS,EPSNEG,FIVE,ONE,QRAN,R6,R7,THREE,W,X,XL,XMAX,XMIN,XN,
     X X1,XSQ,Y,Z,ZERO,ZZ
C
C     IOUT = 6
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      BETA = QEXT(FLOAT(IBETA))
      ALBETA = QLOG(BETA)
      ALXMAX = QLOG(XMAX)
      AIT = QEXT(FLOAT(IT))
      ZERO = 0.0Q+00
      ONE = 1.0Q+00
      THREE = 3.0Q+00
      FIVE = 5.0Q+00
C#    C0 = FIVE/16.0D+00 + 1.152713683194269979D-2
C#    C0 = FIVE/16.0D+00 + ((1/(2*cosh(1))) - 5/16)
      C0 = FIVE/16.0Q+00 +
     X     1.152713683194269978748867661307516155424465603597101152Q-02
      A = ZERO
      B = 0.5Q+00
      C = (AIT + ONE) * 0.35Q+00
      IF (IBETA .EQ. 10) C = C * THREE
      N = 2000
      XN = QEXT(FLOAT(N))
      I1 = 0
      I2 = 2
      NIT = 2 - (IQINT(QLOG(EPS)*THREE))/20
      AIND = QEXT(FLOAT(NIT+NIT+1))
C-----------------------------------------------------------------
C     RANDOM ARGUMENT ACCURACY TESTS
C-----------------------------------------------------------------
      DO 300 J = 1, 4
         IF (J .NE. 2) GO TO 30
         AIND = AIND - ONE
         I2 = 1
   30    K1 = 0
         K3 = 0
         X1 = ZERO
         R6 = ZERO
         R7 = ZERO
         DEL = (B - A) / XN
         XL = A
C
         DO 200 I = 1, N
            X = DEL * QRAN(I1) + XL
            IF (J .GT. 2) GO TO 80
            XSQ = X * X
            ZZ = ONE
            DEN = AIND
C
            DO 40 II = I2, NIT
               W = ZZ * XSQ/(DEN*(DEN-ONE))
               ZZ = W + ONE
               DEN = DEN - 2.0Q+00
   40       CONTINUE
C
            IF (J .EQ. 2) GO TO 50
            W = X*XSQ*ZZ/6.0Q+00
            ZZ = X + W
            Z = QSINH(X)
            IF (IRND .NE. 0) GO TO 110
            W = (X - ZZ) + W
            ZZ = ZZ + (W + W)
            GO TO 110
   50       Z = QCOSH(X)
            IF (IRND .NE. 0) GO TO 110
            W = (ONE - ZZ) + W
            ZZ = ZZ + (W + W)
            GO TO 110
   80       Y = X
            X = Y - ONE
            W = X - ONE
            IF (J .EQ. 4) GO TO 100
            Z = QSINH(X)
            ZZ = (QSINH(Y) + QSINH(W)) * C0
            GO TO 110
  100       Z = QCOSH(X)
            ZZ = (QCOSH(Y) + QCOSH(W)) * C0
  110       W = ONE
            IF (Z .NE. ZERO) W = (Z - ZZ)/Z
            IF (W .GT. ZERO) K1 = K1 + 1
            IF (W .LT. ZERO) K3 = K3 + 1
            W = QABS(W)
            IF (W .LE. R6) GO TO 120
            R6 = W
            X1 = X
  120       R7 = R7 + W * W
            XL = XL + DEL
  200    CONTINUE
C
         K2 = N - K3 - K1
         R7 = QSQRT(R7/XN)
         I = (J/2) * 2
         IF (J .EQ. 1) WRITE (IOUT,1000)
         IF (J .EQ. 2) WRITE (IOUT,1005)
         IF (J .EQ. 3) WRITE (IOUT,1001)
         IF (J .EQ. 4) WRITE (IOUT,1006)
         WRITE (IOUT,1010) N,A,B
         IF (I .NE. J) WRITE (IOUT,1011) K1,K2,K3
         IF (I .EQ. J) WRITE (IOUT,1012) K1,K2,K3
         WRITE (IOUT,1020) IT,IBETA
         W = -999.0Q+00
         IF (R6 .NE. ZERO) W = QLOG(QABS(R6))/ALBETA
         WRITE (IOUT,1021) R6,IBETA,W,X1
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         W = -999.0Q+00
         IF (R7 .NE. ZERO) W = QLOG(QABS(R7))/ALBETA
         WRITE (IOUT,1023) R7,IBETA,W
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         IF (J .NE. 2) GO TO 300
         B = ALXMAX
         A = THREE
  300 CONTINUE
C-----------------------------------------------------------------
C     SPECIAL TESTS
C-----------------------------------------------------------------
      WRITE (IOUT,1025)
      WRITE (IOUT,1030)
C
      DO 320 I = 1, 5
         X = QRAN(I1) * A
         Z = QSINH(X) + QSINH(-X)
         WRITE (IOUT,1060) X, Z
  320 CONTINUE
C
      WRITE (IOUT,1031)
      BETAP = BETA ** IT
      X = QRAN(I1) / BETAP
C
      DO 330 I = 1, 5
         Z = X - QSINH(X)
         WRITE (IOUT,1060) X, Z
         X = X / BETA
  330 CONTINUE
C
      WRITE (IOUT,1032)
C
      DO 340 I = 1, 5
         X = QRAN(I1) * A
         Z = QCOSH(X) - QCOSH(-X)
         WRITE (IOUT,1060) X, Z
  340 CONTINUE
C
      WRITE (IOUT,1035)
      X = BETA ** (QEXT(FLOAT(MINEXP))*0.75Q+00)
      Y = QSINH(X)
      WRITE (IOUT,1061) X, Y
C-----------------------------------------------------------------
C     TEST OF ERROR RETURNS
C-----------------------------------------------------------------
      WRITE (IOUT,1050)
      X = ALXMAX + 0.125Q+00
      WRITE (IOUT,1051) X
      Y = QSINH(X)
      WRITE (IOUT,1055) Y
      X = BETAP
      WRITE (IOUT,1052) X
      Y = QSINH(X)
      WRITE (IOUT,1055) Y
      WRITE (IOUT,1100)
      RETURN
 1000 FORMAT(48H1TEST OF QSINH(X) VS T.S. EXPANSION OF QSINH(X) //)
 1001 FORMAT(49H1TEST OF QSINH(X) VS C*(QSINH(X+1)+QSINH(X-1))   //)
 1005 FORMAT(48H1TEST OF QCOSH(X) VS T.S. EXPANSION OF QCOSH(X) //)
 1006 FORMAT(49H1TEST OF QCOSH(X) VS C*(QCOSH(X+1)+QCOSH(X-1))   //)
 1010 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,1H(,D15.4,1H,,D15.4,1H)//)
 1011 FORMAT(20H QSINH(X) WAS LARGER,I6,7H TIMES, /
     X     13X,7H AGREED,I6,11H TIMES, AND /
     X   9X,11HWAS SMALLER,I6,7H TIMES.//)
 1012 FORMAT(20H QCOSH(X) WAS LARGER,I6,7H TIMES, /
     X     12X,7H AGREED,I6,11H TIMES, AND /
     X   8X,11HWAS SMALLER,I6,7H TIMES.//)
 1020 FORMAT(10H THERE ARE,I4,5H BASE,I4,
     X    46H SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER  //)
 1021 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6)
 1022 FORMAT(27H THE ESTIMATED LOSS OF BASE,I4,
     X  22H SIGNIFICANT DIGITS IS,F7.2//)
 1023 FORMAT(40H THE ROOT MEAN SQUARE RELATIVE ERROR WAS,D15.4,
     X    3H = ,I4,3H **,F7.2)
 1025 FORMAT(14H1SPECIAL TESTS//)
 1030 FORMAT(53H THE IDENTITY  QSINH(-X) = -QSINH(X)  WILL BE TESTED.//
     X      8X,1HX,9X,12HF(X) + F(-X)/)
 1031 FORMAT(53H THE IDENTITY QSINH(X) = X , X SMALL, WILL BE TESTED.//
     X       8X,1HX,9X,8HX - F(X)/)
 1032 FORMAT(52H THE IDENTITY  QCOSH(-X) = QCOSH(X)  WILL BE TESTED.//
     X      8X,1HX,9X,12HF(X) - F(-X)/)
 1035 FORMAT(43H TEST OF UNDERFLOW FOR VERY SMALL ARGUMENT. /)
 1050 FORMAT(22H1TEST OF ERROR RETURNS//)
 1051 FORMAT(39H QSINH WILL BE CALLED WITH THE ARGUMENT,D15.4/
     X       41H THIS SHOULD NOT TRIGGER AN ERROR MESSAGE//)
 1052 FORMAT(39H0QSINH WILL BE CALLED WITH THE ARGUMENT,D15.4/
     X       37H THIS SHOULD TRIGGER AN ERROR MESSAGE//)
 1055 FORMAT(25H QSINH RETURNED THE VALUE,D15.4///)
 1060 FORMAT(D15.7,D25.17/)
 1061 FORMAT(6X,7H QSINH(,D13.6,3H) =,D13.6/)
 1100 FORMAT(25H THIS CONCLUDES THE TESTS )
C     ---------- LAST CARD OF QSINH/QCOSH TEST PROGRAM ----------
      END
      SUBROUTINE  TQSQRT (IOUT)
C     PROGRAM TO TEST QSQRT
C
C     DATA REQUIRED
C
C        NONE
C
C     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
C
C        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
C                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
C                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
C                 BE DELETED PROVIDED THE FOLLOWING SIX
C                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
C
C                 IBETA  - THE RADIX OF THE FLOATING-POINT SYSTEM
C                 IT     - THE NUMBER OF BASE-IBETA DIGITS IN THE
C                          SIGNIFICAND OF A FLOATING-POINT NUMBER
C                 EPS    - THE SMALLEST POSITIVE FLOATING-POINT
C                          NUMBER SUCH THAT 1.0+EPS .NE. 1.0
C                 EPSNEG - THE SMALLEST POSITIVE FLOATING-POINT
C                          NUMBER SUCH THAT 1.0-EPSNEG .NE. 1.0
C                 XMIN   - THE SMALLEST NON-VANISHING FLOATING-POINT
C                          POWER OF THE RADIX
C                 XMAX   - THE LARGEST FINITE FLOATING-POINT NO.
C
C      QRANDL(X) - A FUNCTION SUBPROGRAM RETURNING LOGARITHMICALLY
C                 DISTRIBUTED RANDOM QUADRUPLE PRECISION NUMBERS.
C                 IN PARTICULAR,
C                        A * QRANDL(QLOG(B/A))
C                 IS LOGARITHMICALLY DISTRIBUTED OVER (A,B)
C
C        QRAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1)
C
C
C     STANDARD FORTRAN SUBPROGRAMS REQUIRED
C
C         QABS, QLOG, QMAX1, QFLOAT, QSQRT
C
C
C     LATEST REVISION - AUGUST 2, 1979
C
C     AUTHOR - W. J. CODY
C              ARGONNE NATIONAL LABORATORY
C
C
      INTEGER I,IBETA,IEXP,IOUT,IRND,IT,J,K1,K2,K3,MACHEP,
     X        MAXEXP,MINEXP,N,NEGEP,NGRD
      REAL*16 A,AIT,ALBETA,B,BETA,C,EPS,EPSNEG,ONE,QRANDL,R6,       R7,
     X     SQBETA,W,X,XMAX,XMIN,XN,X1,Y,Z,ZERO
C
C     IOUT = 6
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      BETA = QEXT(FLOAT(IBETA))
      SQBETA = QSQRT(BETA)
      ALBETA = QLOG(BETA)
      AIT = QEXT(FLOAT(IT))
      ONE = 1.0Q+00
      ZERO = 0.0Q+00
      A = ONE / SQBETA
      B = ONE
      N = 2000
      XN = QEXT(FLOAT(N))
C-----------------------------------------------------------------
C     RANDOM ARGUMENT ACCURACY TESTS
C-----------------------------------------------------------------
      DO 300 J = 1, 2
         C = QLOG(B/A)
         K1 = 0
         K3 = 0
         X1 = ZERO
         R6 = ZERO
         R7 = ZERO
C
         DO 200 I = 1, N
            X = A * QRANDL(C)
            Y = X * X
            Z = QSQRT(Y)
            W = (Z - X) / X
            IF (W .GT. ZERO) K1 = K1 + 1
            IF (W .LT. ZERO) K3 = K3 + 1
            W = QABS(W)
            IF (W .LE. R6) GO TO 120
            R6 = W
            X1 = X
  120       R7 = R7 + W * W
  200    CONTINUE
C
         K2 = N - K1 - K3
         R7 = QSQRT(R7/XN)
         WRITE (IOUT,1000)
         WRITE (IOUT,1010) N,A,B
         WRITE (IOUT,1011) K1,K2,K3
         WRITE (6,1020) IT,IBETA
         W = -999.0Q+00
         IF (R6 .NE. ZERO) W = QLOG(QABS(R6))/ALBETA
         WRITE (IOUT,1021) R6,IBETA,W,X1
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         W = -999.0Q+00
         IF (R7 .NE. ZERO) W = QLOG(QABS(R7))/ALBETA
         WRITE (IOUT,1023) R7,IBETA,W
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         A = ONE
         B = SQBETA
  300 CONTINUE
C-----------------------------------------------------------------
C     SPECIAL TESTS
C-----------------------------------------------------------------
      WRITE (IOUT,1040)
      X = XMIN
      Y = QSQRT(X)
      WRITE (IOUT,1041) X,Y
      X = ONE - EPSNEG
      Y = QSQRT(X)
      WRITE (IOUT,1042) EPSNEG,Y
      X = ONE
      Y = QSQRT(X)
      WRITE (IOUT,1043) X,Y
      X = ONE + EPS
      Y = QSQRT(X)
      WRITE (IOUT,1044) EPS,Y
      X = XMAX
      Y = QSQRT(X)
      WRITE (IOUT,1045) X,Y
C-----------------------------------------------------------------
C     TEST OF ERROR RETURNS
C-----------------------------------------------------------------
      WRITE (IOUT,1050)
      X = ZERO
      WRITE (IOUT,1051) X
      Y = QSQRT(X)
      WRITE (IOUT,1055) Y
      X = -ONE
      WRITE (IOUT,1052) X
      Y = QSQRT(X)
      WRITE (IOUT,1055) Y
      WRITE (IOUT,1100)
      RETURN
 1000 FORMAT(24H1TEST OF QSQRT(X*X) - X //)
 1010 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,1H(,D15.4,1H,,D15.4,1H)//)
 1011 FORMAT(20H QSQRT(X) WAS LARGER,I6,7H TIMES, /
     X     13X,7H AGREED,I6,11H TIMES, AND /
     X     9X,11HWAS SMALLER,I6,7H TIMES.//)
 1020 FORMAT(10H THERE ARE,I4,5H BASE,I4,
     X    46H SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER  //)
 1021 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6)
 1022 FORMAT(27H THE ESTIMATED LOSS OF BASE,I4,
     X  22H SIGNIFICANT DIGITS IS,F7.2//)
 1023 FORMAT(40H THE ROOT MEAN SQUARE RELATIVE ERROR WAS,D15.4,
     X    3H = ,I4,3H **,F7.2)
 1040 FORMAT(26H1TEST OF SPECIAL ARGUMENTS//)
 1041 FORMAT(21H QSQRT(XMIN) = QSQRT(,D25.17,4H) = ,D25.17//)
 1042 FORMAT(27H QSQRT(1-EPSNEG) = QSQRT(1-,D15.7,4H) = ,D25.17//)
 1043 FORMAT(20H QSQRT(1.0) = QSQRT(,D25.17,4H) = ,D25.17//)
 1044 FORMAT(24H QSQRT(1+EPS) = QSQRT(1+,D15.7,4H) = ,D25.17//)
 1045 FORMAT(21H QSQRT(XMAX) = QSQRT(,D25.17,4H) = ,D25.17//)
 1050 FORMAT(22H1TEST OF ERROR RETURNS//)
 1051 FORMAT(39H QSQRT WILL BE CALLED WITH THE ARGUMENT,D15.4/
     X       41H THIS SHOULD NOT TRIGGER AN ERROR MESSAGE//)
 1052 FORMAT(39H0QSQRT WILL BE CALLED WITH THE ARGUMENT,D15.4/
     X       37H THIS SHOULD TRIGGER AN ERROR MESSAGE//)
 1055 FORMAT(25H QSQRT RETURNED THE VALUE,D15.4///)
 1100 FORMAT(25H THIS CONCLUDES THE TESTS )
C     ---------- LAST CARD OF QSQRT TEST PROGRAM ----------
      END
      SUBROUTINE  TQTAN (IOUT)
C     PROGRAM TO TEST QWTAN/DCOTAN
C
C     DATA REQUIRED
C
C        NONE
C
C     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
C
C        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
C                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
C                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
C                 BE DELETED PROVIDED THE FOLLOWING THREE
C                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
C
C                 IBETA  - THE RADIX OF THE FLOATING-POINT SYSTEM
C                 IT     - THE NUMBER OF BASE-IBETA DIGITS IN THE
C                          SIGNIFICAND OF A FLOATING-POINT NUMBER
C                 MINEXP - THE LARGEST IN MAGNITUDE NEGATIVE
C                          INTEGER SUCH THAT QFLOAT(IBETA)**MINEXP
C                          IS A POSITIVE FLOATING-POINT NUMBER
C
C        QRAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1)
C
C
C     STANDARD FORTRAN SUBPROGRAMS REQUIRED
C
C         QABS, QLOG, QMAX1, DCOTAN, QFLOAT, DTAN, QSQRT
C
C
C     LATEST REVISION - DECEMBER 6, 1979
C
C     AUTHOR - W. J. CODY
C              ARGONNE NATIONAL LABORATORY
C
C
      INTEGER I,IBETA,IEXP,IOUT,IRND,IT,I1,J,K1,K2,K3,MACHEP,
     X        MAXEXP,MINEXP,N,NEGEP,NGRD
      REAL*16 A,AIT,ALBETA,B,BETA,BETAP,C1,C2,DEL,EPS,EPSNEG,       HALF
     X, PI,QRAN,R6,R7,W,X,XL,XMAX,XMIN,XN,X1,Y,Z,ZERO,ZZ
      REAL*16    QCOTAN
C
C     IOUT = 6
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      BETA = QEXT(FLOAT(IBETA))
      ALBETA = QLOG(BETA)
      ZERO = 0.0Q+00
      HALF = 0.5Q+00
      AIT = QEXT(FLOAT(IT))
C#    PI = 3.14159265D+00
      PI = 3.141592653589793238462643383279502884197169399375105821Q+00
      A = ZERO
      B = PI * 0.25Q+00
      N = 2000
      XN = QEXT(FLOAT(N))
      I1 = 0
C-----------------------------------------------------------------
C     RANDOM ARGUMENT ACCURACY TESTS
C-----------------------------------------------------------------
      DO 300 J = 1, 4
         K1 = 0
         K3 = 0
         X1 = ZERO
         R6 = ZERO
         R7 = ZERO
         DEL = (B - A) / XN
         XL = A
C
         DO 200 I = 1, N
            X = DEL * QRAN(I1) + XL
            Y = X * HALF
            X = Y + Y
            IF (J .EQ. 4) GO TO 80
            Z = QTAN(X)
            ZZ = QTAN(Y)
            W = 1.0Q+00
            IF (Z .EQ. ZERO) GO TO 110
            W = ((HALF-ZZ)+HALF)*((HALF+ZZ)+HALF)
            W = (Z - (ZZ+ZZ)/W) / Z
            GO TO 110
   80       Z = QCOTAN(X)
            ZZ = QCOTAN(Y)
            W = 1.0Q+00
            IF (Z .EQ. ZERO) GO TO 110
            W = ((HALF-ZZ)+HALF)*((HALF+ZZ)+HALF)
            W = (Z+W/(ZZ+ZZ))/Z
  110       IF (W .GT. ZERO) K1 = K1 + 1
            IF (W .LT. ZERO) K3 = K3 + 1
            W = QABS(W)
            IF (W .LE. R6) GO TO 120
            R6 = W
            X1 = X
  120       R7 = R7 + W * W
            XL = XL + DEL
  200    CONTINUE
C
         K2 = N - K3 - K1
         R7 = QSQRT(R7/XN)
         IF (J .NE. 4) WRITE (IOUT,1000)
         IF (J .EQ. 4) WRITE (IOUT,1005)
         WRITE (IOUT,1010) N,A,B
         IF (J .NE. 4) WRITE (IOUT,1011) K1,K2,K3
         IF (J .EQ. 4) WRITE (IOUT,1012) K1,K2,K3
         WRITE (IOUT,1020) IT,IBETA
         W = -999.0Q+00
         IF (R6 .NE. ZERO) W = QLOG(QABS(R6))/ALBETA
         WRITE (IOUT,1021) R6,IBETA,W,X1
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         W = -999.0Q+00
         IF (R7 .NE. ZERO) W = QLOG(QABS(R7))/ALBETA
         WRITE (IOUT,1023) R7,IBETA,W
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
      IF (J .NE. 1) GO TO 250
         A = PI * 0.875Q+00
         B = PI * 1.125Q+00
         GO TO 300
  250    A = PI * 6.0Q+00
         B = A + PI * 0.25Q+00
  300 CONTINUE
C-----------------------------------------------------------------
C     SPECIAL TESTS
C-----------------------------------------------------------------
      WRITE (IOUT,1025)
      WRITE (IOUT,1030)
C
      DO 320 I = 1, 5
         X = QRAN(I1) * A
         Z = QTAN(X) + QTAN(-X)
         WRITE (IOUT,1060) X, Z
  320 CONTINUE
C
      WRITE (IOUT,1031)
      BETAP = BETA ** IT
      X = QRAN(I1) / BETAP
C
      DO 330 I = 1, 5
         Z = X - QTAN(X)
         WRITE (IOUT,1060) X, Z
         X = X / BETA
  330 CONTINUE
C
      WRITE (IOUT,1035)
      X = BETA ** (QEXT(FLOAT(MINEXP))*0.75Q+00)
      Y = QTAN(X)
      WRITE (IOUT,1061) X, Y
C
C     C1 + C2 = TAN(11)
C
      C1 = -225.0Q+00
      C2 = -0.9508464541951420257954832034531539516575098851311946Q+00
      X = 11.0Q+00
      Y = QTAN(X)
      W = ((C1-Y)+C2)/(C1+C2)
      Z = QLOG(QABS(W))/ALBETA
      WRITE (IOUT,1040) W, IBETA, Z
      WRITE (IOUT,1061) X, Y
      W = QMAX1(AIT+Z,ZERO)
      WRITE (IOUT,1022) IBETA, W
C-----------------------------------------------------------------
C     TEST OF ERROR RETURNS
C-----------------------------------------------------------------
      WRITE (IOUT,1050)
      X = BETA ** (IT/2)
      WRITE (IOUT,1051) X
      Y = QTAN(X)
      WRITE (IOUT,1055) Y
      X = BETAP
      WRITE (IOUT,1052) X
      Y = QTAN(X)
      WRITE (IOUT,1055) Y
      WRITE (IOUT,1100)
      RETURN
 1000 FORMAT(49H1TEST OF QTAN(X) VS 2*QTAN(X/2)/(1-QTAN(X/2)**2) //)
 1005 FORMAT(51H1TEST OF QCOT(X) VS (QCOT(X/2)**2-1)/(2*QCOT(X/2)) //)
 1010 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,1H(,D15.4,1H,,D15.4,1H)//)
 1011 FORMAT(19H QTAN(X) WAS LARGER,I6,7H TIMES, /
     X     12X,7H AGREED,I6,11H TIMES, AND /
     X   8X,11HWAS SMALLER,I6,7H TIMES.//)
 1012 FORMAT(19H QCOT(X) WAS LARGER,I6,7H TIMES, /
     X     12X,7H AGREED,I6,11H TIMES, AND /
     X   8X,11HWAS SMALLER,I6,7H TIMES.//)
 1020 FORMAT(10H THERE ARE,I4,5H BASE,I4,
     X    46H SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER  //)
 1021 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6)
 1022 FORMAT(27H THE ESTIMATED LOSS OF BASE,I4,
     X  22H SIGNIFICANT DIGITS IS,F7.2//)
 1023 FORMAT(40H THE ROOT MEAN SQUARE RELATIVE ERROR WAS,D15.4,
     X    3H = ,I4,3H **,F7.2)
 1025 FORMAT(14H1SPECIAL TESTS//)
 1030 FORMAT(51H THE IDENTITY  QTAN(-X) = -QTAN(X)  WILL BE TESTED.//
     X      8X,1HX,9X,12HF(X) + F(-X)/)
 1031 FORMAT(52H THE IDENTITY QTAN(X) = X , X SMALL, WILL BE TESTED.//
     X       8X,1HX,9X,8HX - F(X)/)
 1035 FORMAT(43H TEST OF UNDERFLOW FOR VERY SMALL ARGUMENT. /)
 1040 FORMAT(35H THE RELATIVE ERROR IN QTAN(11) IS ,D15.7,3H = ,
     X       I4,3H **,F7.2,6H WHERE /)
 1050 FORMAT(22H1TEST OF ERROR RETURNS//)
 1051 FORMAT(38H QTAN WILL BE CALLED WITH THE ARGUMENT,D15.4/
     X       41H THIS SHOULD NOT TRIGGER AN ERROR MESSAGE//)
 1052 FORMAT(38H0QTAN WILL BE CALLED WITH THE ARGUMENT,D15.4/
     X       37H THIS SHOULD TRIGGER AN ERROR MESSAGE//)
 1055 FORMAT(24H QTAN RETURNED THE VALUE,D15.4///)
 1060 FORMAT(D15.7,D25.17/)
 1061 FORMAT(6X,6H QTAN(,D23.16,3H) =,D23.16/)
 1100 FORMAT(25H THIS CONCLUDES THE TESTS )
C     ---------- LAST CARD OF QTAN/QCOTAN TEST PROGRAM ----------
      END
      SUBROUTINE  TQTANH (IOUT)
C     PROGRAM TO TEST QTANH
C
C     DATA REQUIRED
C
C        NONE
C
C     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
C
C        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
C                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
C                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
C                 BE DELETED PROVIDED THE FOLLOWING FIVE
C                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
C
C                 IBETA  - THE RADIX OF THE FLOATING-POINT SYSTEM
C                 IT     - THE NUMBER OF BASE-IBETA DIGITS IN THE
C                          SIGNIFICAND OF A FLOATING-POINT NUMBER
C                 MINEXP - THE LARGEST IN MAGNITUDE NEGATIVE
C                          INTEGER SUCH THAT QFLOAT(IBETA)**MINEXP
C                          IS A POSITIVE FLOATING-POINT NUMBER
C                 XMIN   - THE SMALLEST NON-VANISHING FLOATING-POINT
C                          POWER OF THE RADIX
C                 XMAX   - THE LARGEST FINITE FLOATING-POINT NO.
C
C        QRAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1)
C
C
C     STANDARD FORTRAN SUBPROGRAMS REQUIRED
C
C         QABS, QLOG, QMAX1, QFLOAT, QSQRT, QTANH
C
C
C     LATEST REVISION - DECEMBER 6, 1979
C
C     AUTHOR - W. J. CODY
C              ARGONNE NATIONAL LABORATORY
C
C
      INTEGER I,IBETA,IEXP,IOUT,IRND,IT,I1,J,K1,K2,K3,MACHEP,
     X        MAXEXP,MINEXP,N,NEGEP,NGRD
      REAL*16 A,AIT,ALBETA,B,BETA,BETAP,C,D,DEL,EPS,EPSNEG,
     X     EXPON,HALF, ONE,QRAN,R6,R7,W,X,XL,XMAX,XMIN,XN,X1,Y,Z,ZERO,ZZ
C
C     IOUT = 6
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      BETA = QEXT(FLOAT(IBETA))
      ALBETA = QLOG(BETA)
      AIT = QEXT(FLOAT(IT))
      ZERO = 0.0Q+00
      ONE = 1.0Q+00
      HALF = 0.5Q+00
      A = 0.125Q+00
      B = QLOG(3.0Q+00) * HALF
C#    C = 1.2435300177159620805D-1
C#    C = TANH(1/8)
      C = 1.243530017715962080546472758058927076759187925153387504Q-01
      D = QLOG(2.0Q+00) + (AIT+ONE) * QLOG(BETA) * HALF
      N = 2000
      XN = QEXT(FLOAT(N))
      I1 = 0
C-----------------------------------------------------------------
C     RANDOM ARGUMENT ACCURACY TESTS
C-----------------------------------------------------------------
      DO 300 J = 1, 2
         K1 = 0
         K3 = 0
         X1 = ZERO
         R6 = ZERO
         R7 = ZERO
         DEL = (B - A) / XN
         XL = A
C
         DO 200 I = 1, N
            X = DEL * QRAN(I1) + XL
            Z = QTANH(X)
            Y = X - 0.125Q+00
            ZZ = QTANH(Y)
            ZZ = (ZZ + C) / (ONE + C*ZZ)
            W = ONE
            IF (Z .NE. ZERO) W = (Z - ZZ) / Z
            IF (W .GT. ZERO) K1 = K1 + 1
            IF (W .LT. ZERO) K3 = K3 + 1
            W = QABS(W)
            IF (W .LE. R6) GO TO 120
            R6 = W
            X1 = X
  120       R7 = R7 + W * W
            XL = XL + DEL
  200    CONTINUE
C
         K2 = N - K3 - K1
         R7 = QSQRT(R7/XN)
         WRITE (IOUT,1000)
         WRITE (IOUT,1010) N,A,B
         WRITE (IOUT,1011) K1,K2,K3
         WRITE (IOUT,1020) IT,IBETA
         W = -999.0Q+00
         IF (R6 .NE. ZERO) W = QLOG(QABS(R6))/ALBETA
         WRITE (IOUT,1021) R6,IBETA,W,X1
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         W = -999.0Q+00
         IF (R7 .NE. ZERO) W = QLOG(QABS(R7))/ALBETA
         WRITE (IOUT,1023) R7,IBETA,W
         W = QMAX1(AIT+W,ZERO)
         WRITE (IOUT,1022) IBETA,W
         A = B + A
         B = D
  300 CONTINUE
C-----------------------------------------------------------------
C     SPECIAL TESTS
C-----------------------------------------------------------------
      WRITE (IOUT,1025)
      WRITE (IOUT,1030)
C
      DO 320 I = 1, 5
         X = QRAN(I1)
         Z = QTANH(X) + QTANH(-X)
         WRITE (IOUT,1060) X, Z
  320 CONTINUE
C
      WRITE (IOUT,1031)
      BETAP = BETA ** IT
      X = QRAN(I1) / BETAP
C
      DO 330 I = 1, 5
         Z = X - QTANH(X)
         WRITE (IOUT,1060) X, Z
         X = X / BETA
  330 CONTINUE
C
      WRITE (IOUT,1032)
      X = D
      B = 4.0Q+00
C
      DO 340 I = 1, 5
         Z = (QTANH(X) - HALF) - HALF
         WRITE (IOUT,1060) X, Z
         X = X + B
  340 CONTINUE
C
      WRITE (IOUT,1035)
      EXPON = QEXT(FLOAT(MINEXP)) * 0.75Q+00
      X = BETA ** EXPON
      Z = QTANH(X)
      WRITE (IOUT,1061) X, Z
      WRITE (IOUT,1040) XMAX
      Z = QTANH(XMAX)
      WRITE (IOUT,1061) XMAX, Z
      WRITE (IOUT,1040) XMIN
      Z = QTANH(XMIN)
      WRITE (IOUT,1061) XMIN, Z
      X = ZERO
      WRITE (IOUT,1040) X
      Z = QTANH(X)
      WRITE (IOUT,1061) X, Z
      WRITE (IOUT,1100)
      RETURN
 1000 FORMAT(21H1TEST OF QTANH(X) VS ,
     X  54H(QTANH(X-1/8)+QTANH(1/8))/(1+QTANH(X-1/8)QTANH(1/8))   //)
 1010 FORMAT(I7,47H RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL /
     X 6X,1H(,D15.4,1H,,D15.4,1H)//)
 1011 FORMAT(20H QTANH(X) WAS LARGER,I6,7H TIMES, /
     X    13X,7H AGREED,I6,11H TIMES, AND /
     X   9X,11HWAS SMALLER,I6,7H TIMES.//)
 1020 FORMAT(10H THERE ARE,I4,5H BASE,I4,
     X    46H SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER  //)
 1021 FORMAT(30H THE MAXIMUM RELATIVE ERROR OF,D15.4,3H = ,I4,3H **,
     X  F7.2/4X,16HOCCURRED FOR X =,D17.6)
 1022 FORMAT(27H THE ESTIMATED LOSS OF BASE,I4,
     X  22H SIGNIFICANT DIGITS IS,F7.2//)
 1023 FORMAT(40H THE ROOT MEAN SQUARE RELATIVE ERROR WAS,D15.4,
     X    3H = ,I4,3H **,F7.2)
 1025 FORMAT(14H1SPECIAL TESTS//)
 1030 FORMAT(55H THE IDENTITY   QTANH(-X) = -QTANH(X)   WILL BE TESTED./
     X/      8X,1HX,9X,12HF(X) + F(-X)/)
 1031 FORMAT(53H THE IDENTITY QTANH(X) = X , X SMALL, WILL BE TESTED.//
     X       8X,1HX,9X,8HX - F(X)/)
 1032 FORMAT(53H THE IDENTITY QTANH(X) = 1 , X LARGE, WILL BE TESTED.//
     X       8X,1HX,9X,8H1 - F(X)/)
 1035 FORMAT(43H TEST OF UNDERFLOW FOR VERY SMALL ARGUMENT. /)
 1040 FORMAT(52H THE FUNCTION QTANH WILL BE CALLED WITH THE ARGUMENT,
     X   D15.7)
 1060 FORMAT(D15.7,D25.17/)
 1061 FORMAT(6X,7H QTANH(,D13.6,3H) =,D13.6/)
 1100 FORMAT(25H THIS CONCLUDES THE TESTS )
C     ---------- LAST CARD OF QTANH TEST PROGRAM ----------
      END
      REAL*16 FUNCTION QRAN(K)
C
C     RANDOM NUMBER GENERATOR - BASED ON ALGORITHM 266 BY PIKE AND
C      HILL (MODIFIED BY HANSSON), COMMUNICATIONS OF THE ACM,
C      VOL. 8, NO. 10, OCTOBER 1965.
C
C     THE SINGLE PRECISION VERSION OF THIS SUBPROGRAM IS INTENDED
C     FOR USE ON COMPUTERS WITH FIXED POINT WORDLENGTH OF AT
C     LEAST 29 BITS.  IT IS BEST IF THE FLOATING POINT
C     SIGNIFICAND HAS AT MOST 29 BITS.
C
C     FOLLOWING CODY AND WAITE'S RECOMMENDATION (P. 14), WE
C     PRODUCE A PAIR OF RANDOM NUMBERS AND USE
C
C         RAN1 + 2**(-29)*RAN2 + 2**(-2*29)*RAN3 + 2**(-3*29)
C
C     IN AN ATTEMPT TO GENERATE ABOUT 4*29 = 116 RANDOM BITS, WHICH
C     IS SUFFICIENT FOR THE 113-BIT PRECISION OF 128-BIT IEEE 754
C     AND 96-BIT PRECISION OF 128-BIT IBM S/390 ARITHMETIC.
C
      INTEGER IY,J,K
      DATA             IY     /100001/
      REAL*16          TWOP29, TWOP58, TWOP87
      DATA             TWOP29 / 536870912.0Q+00 /
      DATA             TWOP58 / 288230376151711744.0Q+00 /
      DATA             TWOP87 / 154742504910672534362390528.0Q+00 /
C
      J = K
      IY = IY * 125
      IY = IY - (IY/2796203) * 2796203
      QRAN = QEXT(FLOAT(IY)) / 2796203.0Q+00
C
C     2**29 = 536870912
C
      IY = IY * 125
      IY = IY - (IY/2796203) * 2796203
      QRAN = QRAN + (QEXT(FLOAT(IY)) / 2796203.0Q+00) / TWOP29
C
      IY = IY * 125
      IY = IY - (IY/2796203) * 2796203
      QRAN = QRAN + (QEXT(FLOAT(IY)) / 2796203.0Q+00) / TWOP58
C
      IY = IY * 125
      IY = IY - (IY/2796203) * 2796203
      QRAN = QRAN + (QEXT(FLOAT(IY)) / 2796203.0Q+00) / TWOP87
C
      RETURN
C     ---------- LAST CARD OF QRAN ----------
      END
      REAL*16 FUNCTION QRANDL(X)
C
C     RETURNS PSEUDO RANDOM NUMBERS LOGARITHMICALLY DISTRIBUTED
C     OVER (1,QEXP(X)).  THUS A*QRANDL(LN(B/A)) IS LOGARITHMICALLY
C     DISTRIBUTED IN (A,B).
C
C     OTHER SUBROUTINES REQUIRED
C
C        QEXP(X) - THE EXPONENTIAL ROUTINE
C
C        QRAN(K) - A FUNCTION PROGRAM RETURNING RANDOM QUADRUPLE
C                 PRECISION NUMBERS UNIFORMLY DISTRIBUTED OVER
C                 (0,1).  THE ARGUMENT K IS A DUMMY.
C
C
      REAL*16 QRAN,X
      INTEGER K
      DATA K/1/
C
      QRANDL = QEXP(X*QRAN(K))
      RETURN
C     ---------- LAST CARD OF QRANDL ----------
      END
      SUBROUTINE  TSMACH (IOUT)
C     (Test MACHAR)
C     Print the values returned by MACHAR() as a check on the
C     evironmental values.
C     (20-Mar-1993)
      INTEGER             IOUT
      REAL*16 EPS,EPSNEG,XMIN,XMAX
      INTEGER IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP
      CALL MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX)
      WRITE (IOUT,1000) IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     X            MAXEXP,EPS,EPSNEG,XMIN,XMAX
      RETURN
 1000 FORMAT ('1IBETA (floating-point base)           ', I25/
     X        ' IT (number of significand digits)     ', I25/
     X        ' IRND (0: chops, >=1: rounds)          ', I25/
     X        ' NGRD (number of guard digits)         ', I25/
     X        ' MACHEP (see MACHAR)                   ', I25/
     X        ' NEGEPS (see MACHAR)                   ', I25/
     X        ' IEXP (number of exponent bits)        ', I25/
     X        ' MINEXP (exponent of min fp number)    ', I25/
     X        ' MAXEXP (exponent of max fp number)    ', I25/
     X        ' EPS (machine epsilon: 1 + e .ne. 1)   ', 1PE45.34E5/
     X        ' EPSNEG (machine epsilon: 1 - e .ne. 1)', 1PE45.34E5/
     X        ' XMIN (smallest fp number)             ', 1PE45.34E5/
     X        ' XMAX (largest fp number)              ', 1PE45.34E5)
      END
      REAL*16 FUNCTION STORE(X)
      REAL*16 X
      STORE = X
      END
      SUBROUTINE MACHAR(IBETA,IT,IRND,NGRD,MACHEP,NEGEP,IEXP,MINEXP,
     1                   MAXEXP,EPS,EPSNEG,XMIN,XMAX)
C      ALGORITHM 665, COLLECTED ALGORITHMS FROM ACM.
C      THIS WORK PUBLISHED IN TRANSACTIONS ON MATHEMATICAL SOFTWARE,
C      VOL. 14, NO. 4, PP. 303-311.
C-----------------------------------------------------------------------
C  This Fortran 77 subroutine is intended to determine the parameters
C   of the floating-point arithmetic system specified below.  The
C   determination of the first three uses an extension of an algorithm
C   due to M. Malcolm, CACM 15 (1972), pp. 949-951, incorporating some,
C   but not all, of the improvements suggested by M. Gentleman and S.
C   Marovich, CACM 17 (1974), pp. 276-277.  An earlier version of this
C   program was published in the book Software Manual for the
C   Elementary Functions by W. J. Cody and W. Waite, Prentice-Hall,
C   Englewood Cliffs, NJ, 1980.
C
C  The program as given here must be modified before compiling.  If
C   a single (double) precision version is desired, change all
C   occurrences of CS (CD) in columns 1 and 2 to blanks.
C
C  Parameter values reported are as follows:
C
C       IBETA   - the radix for the floating-point representation
C       IT      - the number of base IBETA digits in the floating-point
C                 significand
C       IRND    - 0 if floating-point addition chops
C                 1 if floating-point addition rounds, but not in the
C                   IEEE style
C                 2 if floating-point addition rounds in the IEEE style
C                 3 if floating-point addition chops, and there is
C                   partial underflow
C                 4 if floating-point addition rounds, but not in the
C                   IEEE style, and there is partial underflow
C                 5 if floating-point addition rounds in the IEEE style,
C                   and there is partial underflow
C       NGRD    - the number of guard digits for multiplication with
C                 truncating arithmetic.  It is
C                 0 if floating-point arithmetic rounds, or if it
C                   truncates and only  IT  base  IBETA digits
C                   participate in the post-normalization shift of the
C                   floating-point significand in multiplication;
C                 1 if floating-point arithmetic truncates and more
C                   than  IT  base  IBETA  digits participate in the
C                   post-normalization shift of the floating-point
C                   significand in multiplication.
C       MACHEP  - the largest negative integer such that
C                 1.0+FLOAT(IBETA)**MACHEP .NE. 1.0, except that
C                 MACHEP is bounded below by  -(IT+3)
C       NEGEPS  - the largest negative integer such that
C                 1.0-FLOAT(IBETA)**NEGEPS .NE. 1.0, except that
C                 NEGEPS is bounded below by  -(IT+3)
C       IEXP    - the number of bits (decimal places if IBETA = 10)
C                 reserved for the representation of the exponent
C                 (including the bias or sign) of a floating-point
C                 number
C       MINEXP  - the largest in magnitude negative integer such that
C                 FLOAT(IBETA)**MINEXP is positive and normalized
C       MAXEXP  - the smallest positive power of  BETA  that overflows
C       EPS     - the smallest positive floating-point number such
C                 that  1.0+EPS .NE. 1.0. In particular, if either
C                 IBETA = 2  or  IRND = 0, EPS = FLOAT(IBETA)**MACHEP.
C                 Otherwise,  EPS = (FLOAT(IBETA)**MACHEP)/2
C       EPSNEG  - A small positive floating-point number such that
C                 1.0-EPSNEG .NE. 1.0. In particular, if IBETA = 2
C                 or  IRND = 0, EPSNEG = FLOAT(IBETA)**NEGEPS.
C                 Otherwise,  EPSNEG = (IBETA**NEGEPS)/2.  Because
C                 NEGEPS is bounded below by -(IT+3), EPSNEG may not
C                 be the smallest number that can alter 1.0 by
C                 subtraction.
C       XMIN    - the smallest non-vanishing normalized floating-point
C                 power of the radix, i.e.,  XMIN = FLOAT(IBETA)**MINEXP
C       XMAX    - the largest finite floating-point number.  In
C                 particular  XMAX = (1.0-EPSNEG)*FLOAT(IBETA)**MAXEXP
C                 Note - on some machines  XMAX  will be only the
C                 second, or perhaps third, largest number, being
C                 too small by 1 or 2 units in the last digit of
C                 the significand.
C
C     Latest revision - April 20, 1987
C
C     Author - W. J. Cody
C              Argonne National Laboratory
C
C-----------------------------------------------------------------------
      INTEGER I,IBETA,IEXP,IRND,IT,ITEMP,IZ,J,K,MACHEP,MAXEXP,
     1        MINEXP,MX,NEGEP,NGRD,NXRES
      REAL*16 A,B,BETA,BETAIN,BETAH,CONV,EPS,EPSNEG,ONE,T,TEMP,TEMPA,
     1     TEMP1,TWO,XMAX,XMIN,Y,Z,ZERO
CS    REAL A,B,BETA,BETAIN,BETAH,CONV,EPS,EPSNEG,ONE,T,TEMP,TEMPA,
CS   1     TEMP1,TWO,XMAX,XMIN,Y,Z,ZERO
CD    DOUBLE PRECISION A,B,BETA,BETAIN,BETAH,CONV,EPS,EPSNEG,ONE,
CD   1                 T,TEMP,TEMPA,TEMP1,TWO,XMAX,XMIN,Y,Z,ZERO
      REAL*16 STORE
CS    REAL STORE
CD    DOUBLE PRECISION STORE
C-----------------------------------------------------------------------
CS    CONV(I) = REAL(I)
CD    CONV(I) = DBLE(I)
      CONV(I) = QEXT(DBLE(I))
      ONE = CONV(1)
      TWO = ONE + ONE
      ZERO = ONE - ONE
C-----------------------------------------------------------------------
C  Determine IBETA, BETA ala Malcolm.
C-----------------------------------------------------------------------
      A = ONE
   10 A = STORE(A + A)
         TEMP = STORE(A+ONE)
         TEMP1 = STORE(TEMP-A)
         IF (STORE(TEMP1-ONE) .EQ. ZERO) GO TO 10
      B = ONE
   20 B = B + B
         TEMP = STORE(A+B)
         ITEMP = INT(STORE(TEMP-A))
         IF (ITEMP .EQ. 0) GO TO 20
      IBETA = ITEMP
      BETA = CONV(IBETA)
C-----------------------------------------------------------------------
C  Determine IT, IRND.
C-----------------------------------------------------------------------
      IT = 0
      B = ONE
  100 IT = IT + 1
         B = B * BETA
         TEMP = STORE(B+ONE)
         TEMP1 = STORE(TEMP-B)
         IF (STORE(TEMP1-ONE) .EQ. ZERO) GO TO 100
      IRND = 0
      BETAH = BETA / TWO
      TEMP = STORE(A+BETAH)
      IF (STORE(TEMP-A) .NE. ZERO) IRND = 1
      TEMPA = STORE(A + BETA)
      TEMP = STORE(TEMPA+BETAH)
      IF ((IRND .EQ. 0) .AND. (STORE(TEMP-TEMPA) .NE. ZERO)) IRND = 2
C-----------------------------------------------------------------------
C  Determine NEGEP, EPSNEG.
C-----------------------------------------------------------------------
      NEGEP = IT + 3
      BETAIN = ONE / BETA
      A = ONE
      DO 200 I = 1, NEGEP
         A = A * BETAIN
  200 CONTINUE
      B = A
  210 TEMP = STORE(ONE-A)
         IF (STORE(TEMP-ONE) .NE. ZERO) GO TO 220
         A = A * BETA
         NEGEP = NEGEP - 1
      GO TO 210
  220 NEGEP = -NEGEP
      EPSNEG = A
      IF ((IBETA .EQ. 2) .OR. (IRND .EQ. 0)) GO TO 300
      A = (A*STORE(ONE+A)) / TWO
      TEMP = STORE(ONE-A)
      IF (STORE(TEMP-ONE) .NE. ZERO) EPSNEG = A
C-----------------------------------------------------------------------
C  Determine MACHEP, EPS.
C-----------------------------------------------------------------------
  300 MACHEP = -IT - 3
      A = B
  310 TEMP = STORE(ONE+A)
         IF (STORE(TEMP-ONE) .NE. ZERO) GO TO 320
         A = A * BETA
         MACHEP = MACHEP + 1
      GO TO 310
  320 EPS = A
      TEMP = STORE(TEMPA+BETA*(ONE+EPS))
      IF ((IBETA .EQ. 2) .OR. (IRND .EQ. 0)) GO TO 350
      A = STORE((A*STORE(ONE+A)) / TWO)
      TEMP = STORE(ONE+A)
      IF (STORE(TEMP-ONE) .NE. ZERO) EPS = A
C-----------------------------------------------------------------------
C  Determine NGRD.
C-----------------------------------------------------------------------
  350 NGRD = 0
      TEMP = STORE(ONE+EPS)
      IF ((IRND .EQ. 0) .AND. (STORE(TEMP*ONE-ONE) .NE. ZERO)) NGRD = 1
C-----------------------------------------------------------------------
C  Determine IEXP, MINEXP, XMIN.
C
C  Loop to determine largest I and K = 2**I such that
C         (1/BETA) ** (2**(I))
C  does not underflow.
C  Exit from loop is signaled by an underflow.
C-----------------------------------------------------------------------
      I = 0
      K = 1
      Z = BETAIN
      T = ONE + EPS
      NXRES = 0
  400 Y = Z
         Z = Y * Y
C-----------------------------------------------------------------------
C  Check for underflow here.
C-----------------------------------------------------------------------
         A = Z * ONE
         TEMP = Z * T
         IF ((STORE(A+A) .EQ. ZERO) .OR. (ABS(Z) .GE. Y)) GO TO 410
         TEMP1 = TEMP * BETAIN
         IF (STORE(TEMP1*BETA) .EQ. Z) GO TO 410
         I = I + 1
         K = K + K
      GO TO 400
  410 IF (IBETA .EQ. 10) GO TO 420
      IEXP = I + 1
      MX = K + K
      GO TO 450
C-----------------------------------------------------------------------
C  This segment is for decimal machines only.
C-----------------------------------------------------------------------
  420 IEXP = 2
      IZ = IBETA
  430 IF (K .LT. IZ) GO TO 440
         IZ = IZ * IBETA
         IEXP = IEXP + 1
      GO TO 430
  440 MX = IZ + IZ - 1
C-----------------------------------------------------------------------
C  Loop to determine MINEXP, XMIN.
C  Exit from loop is signaled by an underflow.
C-----------------------------------------------------------------------
  450 XMIN = Y
         Y = Y * BETAIN
C-----------------------------------------------------------------------
C  Check for underflow here.
C-----------------------------------------------------------------------
         A = STORE(Y * ONE)
         TEMP = STORE(Y * T)
         IF ((STORE(A+A) .EQ. ZERO) .OR. (ABS(Y) .GE. XMIN)) GO TO 460
         K = K + 1
         TEMP1 = STORE(TEMP * BETAIN)
         IF (STORE(TEMP1*BETA) .NE. Y) GO TO 450
      NXRES = 3
      XMIN = Y
  460 MINEXP = -K
C-----------------------------------------------------------------------
C  Determine MAXEXP, XMAX.
C-----------------------------------------------------------------------
      IF ((MX .GT. K+K-3) .OR. (IBETA .EQ. 10)) GO TO 500
      MX = MX + MX
      IEXP = IEXP + 1
  500 MAXEXP = MX + MINEXP
C-----------------------------------------------------------------
C  Adjust IRND to reflect partial underflow.
C-----------------------------------------------------------------
      IRND = IRND + NXRES
C-----------------------------------------------------------------
C  Adjust for IEEE-style machines.
C-----------------------------------------------------------------
      IF ((IRND .EQ. 2) .OR. (IRND .EQ. 5)) MAXEXP = MAXEXP - 2
C-----------------------------------------------------------------
C  Adjust for non-IEEE machines with partial underflow.
C-----------------------------------------------------------------
      IF ((IRND .EQ. 3) .OR. (IRND .EQ. 4)) MAXEXP = MAXEXP - IT
C-----------------------------------------------------------------
C  Adjust for machines with implicit leading bit in binary
C  significand, and machines with radix point at extreme
C  right of significand.
C-----------------------------------------------------------------
      I = MAXEXP + MINEXP
      IF ((IBETA .EQ. 2) .AND. (I .EQ. 0)) MAXEXP = MAXEXP - 1
      IF (I .GT. 20) MAXEXP = MAXEXP - 1
      IF (A .NE. Y) MAXEXP = MAXEXP - 2
      XMAX = ONE - EPSNEG
      IF (STORE(XMAX*ONE) .NE. XMAX) XMAX = ONE - BETA * EPSNEG
      XMAX = XMAX / (BETA * BETA * BETA * XMIN)
      I = MAXEXP + MINEXP + 3
      IF (I .LE. 0) GO TO 520
      DO 510 J = 1, I
          IF (IBETA .EQ. 2) XMAX = XMAX + XMAX
          IF (IBETA .NE. 2) XMAX = XMAX * BETA
  510 CONTINUE
  520 RETURN
C---------- LAST CARD OF MACHAR ----------
      END
